   #end dircategory

ASynK User Manual
*****************

This file documents "ASynK - Awesome Sync (by Karra)"

   Copyright (C) 2011, 2012, 2013, 2014, 2015 Sriram Karra
<karra.etc@gmail.com>

     Permission is granted to copy, distribute and/or modify this
     document under the terms of the GNU Free Documentation License,
     Version 1.3; with the Invariant Section being "GNU GENERAL PUBLIC
     LICENSE," A copy of the license is included in the section entitled
     "GNU Free Documentation License."

Appendices

1 Introduction
**************

ASynK is a flexible Contacts synchronization program that works with a
variety of Contacts software such as Microsoft Outlook, Microsoft
Exchange Server, Google Contacts, CardDAV and Emacs BBDB.

   If you would not read through this documentation from cover to
cover, but rather learn by looking at examples, head straight to the
section titled "Recipes". It contains enough examples to help you get
going.

   So, where were we? Ah, yes, introducing ASynK. Here are some of the
high level features of ASynK:

  1. ASynK allows two-way sync of Contacts across any two supported
     sources. For e.g. you can use this to copy contacts from one
     Google account to another, or from your Google account and your
     official MS Exchange account etc.

  2. ASynK is the only two-way synchronization option for BBDB known to
     be in existence today. So if you are keen to keep your BBDB
     content synchronized with a mobile device or Outlook, look no
     further.

  3. ASynK works on Windows, MacOS X, and Linux. Outlook synchronization
     only works on Windows.

  4. Synchronization is granular to the level of 'Folders', i.e. you can
     synchronize one folder of Google Contacts with a Outlook folder
     (on Windows at work, say), and another Google folder in the same
     account with BBDB (On your Mac, say)

  5. The infrastructure is there to add more database and item types
     (i.e. tasks, notes, etc.), but currently only Contacts
     synchronization is supported

  6. It is free software, and released under the GNU AGPL (Affero GPL)
     version 3

2 Getting ASynK and Installation
********************************

The official website for ASynK is at: `http://asynk.io'. You will find
links to latest downloads, complete and latest documentaiton,
announcements and other information on that website.

   The source code for ASynK is hosted on Github at:
`https://github.com/skarra/AsynK' (earlier hosted at:
`https://github.com/skarra/Gout') Visit the site to grab the bleeding
edge development version, or to register an issue you have identified.

2.1 Pre-packaged Bundle
=======================

You can download the latest version by visiting the downloads section
of the official website at `http://asynk.io/downloads/'.

2.2 From Source
===============

You can clone the git repository by using a command such as `git clone
git://github.com/skarra/ASynK.git'. Then run `asynk.py' as per
instructions given in the Using ASynK, section below.

2.3 Dependencies / Notes
========================

2.3.1 General Dependencies
--------------------------

  1. *Python 2.7*. You can download Python from:
     `http://www.python.org/download/releases/'

  2. If you want to build the documentation yourself you will need some
     additional tools:
       1. *makeinfo*: Is needed to build documentation in Info, docbook
          and xml formats. Version 4.8 is known to work with our
          sources.

       2. *texi2html*: Is needed to build documentation in html format.
          Version 1 .70 is known to work with our sources.

       3. *texi2pdf*: Is needed to build the documentation in PDF
          format. Version 1.34 is known to work with our sources.

2.3.2 Microsoft Exchange Specific Notes
---------------------------------------

If you want to synchronize to your Exchange Server you could do that
from any machine or operating system that can access your Exchange
server over the internet. You will need to ask  your system
administrators for:

  1. Your full email address

  2. Your account password

  3. The exchange mailbox url

2.3.3 Windows / Outlook Specific Notes
--------------------------------------

If you have contacts on your own machine inside a Outlook PST file you
can sycn them too. But there are a few additional dependencies:

  1. *Microsoft Windows*: You must run ASynK on a Windows machine. Any
     recent version such as XP onwards will do.

  2. *MS Outlook*: Outlook should be installed. Direct read/write of PST
     files is not possible. Any recent version should work. ASynK has
     been reported to work with Office 2007, Office 2008, Office 2010,
     Office 2013

  3. *Pywin32 for Python 2.7*: It is available for download
     `http://sourceforge.net/projects/pywin32/files/pywin32'

2.3.4 CardDAV Specific Notes
----------------------------

Keep in mind that unlike Google Contacts, CardDAV servers do not
support a roll back feature. This means any ASynK bugs could
potentially lead to loss of information for you. While there have been
no complaints of ASynK eating up people's data, please take your own
precautions before you deploy this on your live data. The use of the
`--user-dir=' option is also high encouraged.

   At the moment the following fields are synched in both ways. More
may be supported over time.  *Important*: Fields not mentioned here
will be lost in transit!

  1. First name

  2. Last name

  3. Middle name

  4. Formatted name

  5. Suffix, Prefix

  6. Gender

  7. Email addresses

  8. Phone numbers

  9. Title

 10. Department

 11. Company name

 12. Notes

   Specifically, the following are not synched:

  1. IM

  2. WWW

  3. Postal Addresses

  4. Custom fields

2.3.5 BBDB Specific Notes
-------------------------

ASynK can parse and write BBDB files without the need for Emacs or
BBDB. However, ensure you are NOT using BBDB at the time ASynK is
reading/writing the database. Bad things can happen if you are not
careful with this. Furthermore, note the following:

  1. *BBDB V3*: ASynK works best if you use BBDBV3. V3 is the future of
     BBDB and a significant rewrite of large portions of the code base,
     but is decidedly not backward compatible with most user
     customization. You can download it at
     `http://savannah.nongnu.org/projects/bbdb'.

     Importantly for ASynK, the file format used by V3 provides for
     granular time stamps with timezone information and ASynK will just
     work "out of the box". There are also other important changes to
     the structure of the BBDB record in file format version 7.

  2. *Timestamp Customization*: ASynK expects timestamps to be in UTC -
     i.e. they should all end with the `+0000'. If you have customized
     your BBDB timestamp format, it can lead to confusing results.

  3. *BBDB-2.x*: Starting release v0.2.1 ASynK has added limited
     support for BBDB file format version 6 which is the latest version
     used by the 2.x releases of BBDB. This version of BBDB is not
     actively maintained, but is more widely deployed because of its
     age and availability on XEmacs.

     Support is limited in the sense that the native ver 6 file format
     timestamps only store year, month and day. So BBDB will overwrite
     the granular ASynK timestamps with a yyyy-mm-dd timestamp, and
     your bi-directional sync will not quite work as you would like.

     The above limitation can be overcome by applying the following
     simple patch. With this patch in place ASynK will work quite well.
     There is a downside, however - certain time-based search in BBDB
     may behave differently (search newer, search older etc. will
     behave differently owing to differences in timestamp format). But
     one would like to think the ability to do bidirectional sync
     outweighs this minor irritation.

     commit eb6ba8d342a46d61c45b0ce4c1de7711ff011466
     Author: Sriram Karra <karra.etc@gmail.com>
     Date:   Wed May 16 18:09:50 2012 +0530

         Include UTC time as part of timestamp

         This is a feature in file format 7 available with BBDB v3. However
         that is not available with the 2.x series. A detailed timestamp
         is needed to do a sync with a third party.

         The ideal way would have been to fully implement the version 7
         changes on 2.36. However that involves a lot of changes and is
         risky - for e.g. introducing a new key name field (affix)
         will stretch my understanding of BBDB internals. Best to just
         provide a quick hack for those willing to live with it only to
         try ASynK or similar sync software.

         The obvious pitfall is that commands that work on the timestamp
         field (like newer or older filters and delete) will start
         to behave differently because a string comparison is done to
         check if a date is newer or older.

            *** You have been warned ***

     diff --git a/lisp/bbdb-hooks.el b/lisp/bbdb-hooks.el
     index 01de4f2..b9f0d9d 100644
     --- a/lisp/bbdb-hooks.el
     +++ b/lisp/bbdb-hooks.el
     @@ -59,7 +59,7 @@
      (defvar mh-show-buffer)

     -(defvar bbdb-time-internal-format "%Y-%m-%d"
     +(defvar bbdb-time-internal-format "%Y-%m-%d %T %z"
        "The internal date format.")

      ;;;###autoload
     @@ -69,7 +69,7 @@ for the given record which contains the time when it was last modified.  If
      there is such a field there already, it is changed, otherwise it is added."
        (bbdb-record-putprop record 'timestamp (format-time-string
                            bbdb-time-internal-format
     -                      (current-time))))
     +                      (current-time) t)))

      ;;;###autoload
      (defun bbdb-creation-date-hook (record)
     @@ -78,7 +78,7 @@ which is the current time string."
        ;; hey buddy, we've known about your antics since the eighties...
        (bbdb-record-putprop record 'creation-date (format-time-string
                                bbdb-time-internal-format
     -                          (current-time))))
     +                          (current-time) t)))

      ;;; Determining whether to create a record based on the content of the
     diff --git a/lisp/bbdb.el b/lisp/bbdb.el
     index cc12045..dabbf05 100644
     --- a/lisp/bbdb.el
     +++ b/lisp/bbdb.el
     @@ -1214,7 +1214,7 @@ from string."

      ;;; Address formatting.

     -(defcustom bbdb-time-display-format "%d %b %Y"
     +(defcustom bbdb-time-display-format "%d %b %Y %T %z"
        "The format for the timestamp to be used in the creation-date and
      timestamp fields.  See the documentation for `format-time-string'."
        :group 'bbdb :type 'string)
     @@ -1223,11 +1223,13 @@ timestamp fields.  See the documentation for `format-time-string'."
        "Convert a date from the BBDB internal format to the format
      determined by FORMAT (or `bbdb-time-display-format' if FORMAT not
      present).  Returns a string containing the date in the new format."
     -  (let ((parts (bbdb-split date "-")))
     -    (format-time-string (or format bbdb-time-display-format)
     -                        (encode-time 0 0 0 (string-to-number (caddr parts))
     -                                     (string-to-number (cadr parts))
     -                                     (string-to-number (car parts))))))
     +  (format-time-string (or format bbdb-time-display-format)
     +		      (condition-case err
     +			  (date-to-time date)
     +			(error nil
     +			       (date-to-time (concat date " 00:00:00
     +			       +0000"))))
     +		      t))

      (defalias 'bbdb-format-record-timestamp 'bbdb-time-convert)
      (defalias 'bbdb-format-record-creation-date 'bbdb-time-convert)

2.4 Building & Installing Documentation
=======================================

The user documentation is in the directory called doc/ in the root of
the ASynK source tree. The main source file is asynk.texi in TexInfo
format. HTML, PDF and Info files are available on the project    home
page at: http://asynk.io

   If you wish to build the documentation from source, you can try the
 Makefile in the documentation directory, like so:

   $ cd doc
   $ make pdf
   $ make       # Builds all the targets
   $ make clean
   $ make distclean

   The supported doc types are: 'pdf', 'html', 'info', 'docbook', and
'text'. You may    have to install additional programs like makeinfo,
texi2html etc. See the    "Dependencies" section above.

3 Concepts
**********

This chapter explains some of the key terminology we will use through
the rest of this documentation. This is also required reading before
you can dig into the code, if you are so inclined.

3.1 Your Information and How it is Organized
============================================

3.1.1 "PIMDB"s
--------------

Google, MS Outlook and BBDB are know as "PIM Databases", and each is a
"PIM DB", or "pimdb". PIM stands for Personal Information Manager.
PIMDB is PIM Database.

   Each PIMDB is referred to using a unique two letter specifier -'bb'
for BBDB, 'gc' for Google Contacts, 'cd' for CardDAV and 'ol' for
Outlook. This two letter specifier is called a "dbid"

3.1.2 "Item"s
-------------

Your personal information collection includes contacts, notes,
appointments, and tasks. In AsynK we refer to each piece of PIM
information in your databases as an "Item". When we want to refer a
specific type of Item we would refer to them as Items - "Contact",
"Task", "Note", or "Appointment" as applicable.

   Every Item has an ID known as a "ItemID" that is guaranteed to be
unique within its containing "Folder".

   A pimdb can contain one or more Item types. Outlook supports all of
them. Google covers Contacts and Appointments well, and BBDB only does
contacts. In future we will be able to deal with all the contact types,
but for now, the only support is for Contacts.

3.1.3 "Message Store"
---------------------

Instead of defining a message store in general terms, let me just give
you what they are for each of the "PIMDB"s we have.

   In Google, a "Message Store" is identified by a user login/password.
If you have two Google accounts you have access to two "Message Store"s
on Google Contacts.

   With CardDAV, as you can have any number server and a user
login/password for your account on that server. In this case a "Message
Store" is the server name - with a leading http or https, and a
trailing port number, and associated user credentials.

   With MS Outlook, there is a built in concept of a "MessageStore".
Each account you create becomes a "Message Store". If you add a PST
file to your profile, it becomes a distinct "Message Store".
Essentially, The ASynK "Message Store" corresponds directly with a
Outlook Message Store.

   A Note on Outlook Profiles: ASynK only works on the default Outlook
Profile, and the contained Stores, folders, and contacts. This is
important to keep in mind. You cannot specify a different Outlook
profile to operate on.

   And finally, in BBDB, a BBDB file is the "Message Store". Simple :)

3.1.4 "Folders"
---------------

"Message Stores" are logically divided into "Folder"s. Google and
Outlook internally organize their items into Folders (Google actually
calls them Groups), but there is no native folder support in BBDB.

   Folders are assigned a unique ID determined by the PIMDB, and
typically when the folder is created. ASynK provides a way of viewing
the available folders, their names, and IDs in a given "PIMDB" /
"Message Store".

3.1.4.1 Folders in BBDB
.......................

The fact that there is no native folder support in BBDB is more than
offset by the fact that is infinitely customizable, and we can support
a user-level model of folders as we wish. This is how it works:

   Normally, all the contacts in a BBDB "store" will be in a folder
called "default". If, however, a contact has a notes field with key
titled "folder", it will be put into the logical folder with the name
specified in the value part of that BBDB notes. For e.g. if `(``folder''
. ``Buddies'')' is a notes field in a contact, the ASynK will treat it
as being in the folder called "Buddies".

   If you do not like the "folder" key for your BBDB notes field, and
want to call it "group" instead, you can do that too. Refer to the
Customizing AsynK chapter below on how this can be done.

   A BBDB folder's Name and ID are the same, and are taken from the
value of the notes field as explained above.

3.2 ASynK Profile
=================

ASynK allows you to keep any folder in a pimdb in sync with any folder
in one of the other pimdbs. The configuration and state of
synchronization between a pair of folders is captured in a sync
"Profile". Most ASynK operations operate on a specified sync profile.
So you will need to set up at least one profile before you can play
with ASynK.

   Each Profile has the following information associated with it:

  1. *Name*: A unique alphanumeric string that identifies the profile,
     and is required for most sync operations. This is specified at the
     time of profile creation, and has to be provided by the user. A
     profile's name cannot be changed after creation.

  2. *Folder IDs*: The IDs for the two folders that are to be synched.
     The required IDs have to be specified by the user at the time of
     profile creation. The IDs are assigned by the PIM DBs when the
     folders are created. ASynK can be used to list the existing
     folders in a PIMDB and their IDs, so the user can use the
     appropriate IDs at profile creation time.

  3. *DB IDs*: Two DB IDs that hold the folders that are to be synched.
     This is specified at the time of profile creation and has to be
     specified by the user. They have to one of the supported DB IDs,
     which are 'bb', 'gc', 'cd' and 'ol', in this version. The order in
     which the DB IDs are specified matters - as explained below.

  4. *Sync Timestamps*: The start and end of the last successful sync
     operation for this profile.  The end of the last sync is the
     timestamp used to query the pimdbs for updates that have to be
     synched. These are initialized and updated automatically by the
     system and you do not have to worry about it.

  5. *Conflict Resolution Direction*: Occasionally one ends up editing
     an item in multiple places or devices, and this situation leads to
     a conflict - i.e. the same item has been updated since the last
     sync on both ends. There is no magic way to figure out which is
     the correct version. So we have to use a pre-determined tie
     breaker. This parameter tells the system in which direction to
     resolve this conflict. This field can be specified at the time of
     profile creation, but defaults to the first dbid specified in the
     profile. Once profile is created, the direction of conflict
     resolution cannot be specified for a operation.

  6. *Sync Direction*: Although ASynK is designed to be a two way sync,
     you might be interested in setting up certain profiles to sync in
     only one direction - i.e. new entries and updates to existing
     entries will only flow in one direction. This can be specified at
     the time of profile creation and also be specified for every sync
     operation. If it is a one way sync, currently the flow will be
     from db1 to db2 (i.e. the first db in the profile to the second
     db). Note: This has to be fixed.

4 Using ASynK
*************

Recent releases of ASynK (v0.2.0+) only support a command line user
interface - even on Windows. Once you have your platform-specific
dependencies installed, there is no difference at all in the way ASynK
is invoked on any platform.

   There are plans to develop a browser-based GUI, but work on that has
not started yet.

4.1 Invoking Help
=================

As of the latest version, only a command line interface is available.
There are plans to provide a browser based UI at a later stage.

   To run ASynK, change to the root of the downloaded ASynK directory,
and type `python asynk.py -h' to get a detailed help screen as show
below. In the following sections we look at each of the flags and
options in detail (in time, of course).

Srirams-MacBook-Pro:asynk.co sriramkarra$ ./asynk.py --help
usage: asynk.py [-h] [--dry-run] [--sync-all]
                [--op {list-folders,create-folder,create-store,show-folder,del-folder,list-profiles,list-profile-names,find-profile,create-profile,show-profile,del-profile,sync,clear-sync-artifacts}]
                [--user-dir USER_DIR]
                [--db {bb,gc,ol,cd,ex} [{bb,gc,ol,cd,ex} ...]]
                [--store STORE [STORE ...]] [--folder FOLDER [FOLDER ...]]
                [--item ITEM] [--name NAME] [--direction {1way,2way}]
                [--label-regex LABEL_REGEX]
                [--conflict-resolve CONFLICT_RESOLVE]
                [--gcpwd GCPWD [GCPWD ...]] [--cduser CDUSER [CDUSER ...]]
                [--cdpwd CDPWD [CDPWD ...]]
                [--log {debug,info,error,critical}] [--version]

ASynK: PIM Awesome Sync by Karra

optional arguments:
  -h, --help            show this help message and exit
  --dry-run             Do not sync, but merely show what will happen if a
                        sync is performed.
  --sync-all            when used with --op=sync, this will ignore previous
                        synchronization state, and perform a complete resync.
  --op {list-folders,create-folder,create-store,show-folder,del-folder,list-profiles,list-profile-names,find-profile,create-profile,show-profile,del-profile,sync,clear-sync-artifacts}
                        Specific management operation to be performed.
  --user-dir USER_DIR   Directory to store ASynK config files, logs directory,
                        BBDB backups directory, etc.
  --db {bb,gc,ol,cd,ex} [{bb,gc,ol,cd,ex} ...]
                        DB IDs required for most actions. Some actions need
                        two DB IDs - do it with two --db flags. When doing so
                        remember that order might be important for certain
                        operations.
  --store STORE [STORE ...]
                        Specifies store ID(s) to be operated on.
  --folder FOLDER [FOLDER ...]
                        For operations that need folder ids, this option
                        specifies them. More than one can be specified
                        separated by spaces
  --item ITEM           For Item operations specify the ID of the Item to
                        operate on.
  --name NAME           For profile operations, specifies profile name. For
                        Folder operations, specifies folder name
  --direction {1way,2way}
                        Specifies whether a sync has to be unidirectional or
                        bidirectional. Defaults to bidirectional sync, i.e.
                        "2way"
  --label-regex LABEL_REGEX
                        A regular expression for sync artification to be
                        cleared from specified folder. This is to be used
                        independently of any sync profile.
  --conflict-resolve CONFLICT_RESOLVE
                        Specifies how to deal with conflicts in case of a
                        bidirectional sync and an item is modified in both
                        places. It should be set to 1 or 2 to specify the one
                        to be used; in case the dbs are unique. For e.g. if
                        you are synching from BBDB to Google Contacts, then
                        you can also specify the dbid itself (i.e. bb or gc)
  --log {debug,info,error,critical}
                        Specify level of console logging. Note that DEBUG
                        level logs are always written to a log file for
                        tracking purposes
  --version             show program's version number and exit

Google Authentication:
  --gcpwd GCPWD [GCPWD ...]
                        Google password. Relevant only if --db=gc is used. You
                        can specify two if you are operating with 2 gc dbs.
                        You could also specify one from netrc and one on the
                        command line. First one can optionally be "None"
                        (without the quotes). If this option is not specified,
                        user is prompted password from stdin as required.

CardDAV Server Authentication:
  --cduser CDUSER [CDUSER ...]
                        CardDAV username. Relevant only if --db=cd is used.
                        You can specify two if you are operating with 2 cd
                        dbs. You could also specify one from netrc and one on
                        the command line. First one can optionally be "None"
                        (without the quotes). If this option is not specified,
                        user is prompted for it from stdin if required.
  --cdpwd CDPWD [CDPWD ...]
                        CardDAV password. Relevant only if --db=cd is used.
                        You can specify two if you are operating with 2 cd
                        dbs. You could also specify one from netrc and one on
                        the command line. First one can optionally be "None"
                        (without the quotes). If this option is not specified,
                        user is prompted for it from stdin if required.

   TODO: Detailed documentation on what each of the above flags mean,
etc.

5 Customization
***************

ASynK differentiates between application configuration and application
state. Configuration is user-facing key-value information, and
something that a user does not typically change in the middle of a run.
Configuration tells ASynK what to sync, where to put log files, etc.

   Application state, on the other hand, is not meant to be modified
directly by the user. It is used internally by the program to manage
various things about the sync, etc.

   In this section we only talk about application configuration. The
application state is explained in more detail in the Internals,
section.

5.1 `config.json' and `config.py'
=================================

The entire application configuration is stored as a JSON file in the
application_root/config/ directory. It has copious comments and
explanation of its various fields, so we will only list the main
configurable parameters here, and will just point you to the source to
find out more. You should not edit this JSON file directly as it might
get updated in subsquent releases of ASynK.

   All of your own customizations should be placed in the file
~/.asynk/config.py. You can look in the file for example customizations
and further instructions. The first time you run ASynK, a copy of a
sample config.py is made to ~/.asynk (which is the default per-user
asynk config directory), or to a directory specified with the
`--user-dir' command line option. For all subsequent runs, the default
config.json is loaded, then the user customizations are executed by
loading the config.py file from the user directory.

  1. Location of directory containing logs. This should be the name of
     a directory relative to the ASynK user directory, which is
     ~/.asynk/ by default.

  2. The prefix and separator to use for the ASynK sync tags/labels.

  3. Default values for newly created profile, like sync direction, etc.

  4. DB specific configuration. There are many instances where the
     capabilities of one PIM DB does no match another's. If care is not
     take to bridge this gap, synching back and forth could lead to
     loss of information. ASynK is designed to ensure this does not
     happen, and we try very hard.

     Bridging this gap sometimes means taking a call on how to handle a
     particular situation. We have tried to make these essentially
     arbitrary calls configurable so interested users can tweak this to
     their liking.

       1. Outlook

            1. _The fields to be synched_: Outlook has a gazillion
               properties, many of them seemingly redundant. We have
               identified a subset of the really relevant ones here,
               and you can add or remove stuff you want or don't want.

            2. _Email classification by domains_: Outlook does not
               really classify email addresses into Work, Home, Other
               etc. like Google does. Here you can tell ASynK how to do
               that based on the email addresses.

       2. BBDB

            1. Location of directory containing backup of BBDB stores.
               This should the name of a directory relative to the
               asynk user directory, which is ~/.asynk/ by default.

            2. _Text Encodings_: The list of text encodings that you
               want ASynK to try while attempting to read your BBDB

            3. _Email classification by domains_: Same as explained for
               Outlook

            4. _Postal address map_: Same as above, except that this is
               for postal addresses.

            5. _Phones map_: Ditto, for phones

            6. _Notes map_: BBDB really is really flexible, to the
               point that very basic fields are not standardized. There
               is no date of birth, middle name, web url, gender, and
               similar fields. However one can always have such data as
               a user-defined field. This map allows the mapping from a
               bbdb field name to one of the standard fields.

       3. Google Contacts

            1. _Postal Map_: Google's address system is interesting - a
               user can either have a standard category, or a user
               defined label. A generic user defined label has the same
               problem as with others - it is hard to classify. So we
               need a map for Google as well.

     Note that your sync field customizations for all the databases
     should be consistent, otherwise there would be information loss as
     you sync your contacts around.

5.2 Authentication using ~/.netrc
=================================

For Google and CardDAV you are required to provide a username and
password to perform most operations. These credentials can be specified
in a number of ways including command line flags, or through the STDIN
on being prompted for them. There is yet another way to set this up
that will reduce your typing and will consolidate all your asynk
related authentication information in the same place. That is by using
the ~/.netrc file.

   Let's say you have a ASynK profile named `testbbcc' connects your
BBDB file to a Google Contacts account. You can specify the auth
credentials for this profile by inserting the following lines in youru
~/.netrc.

machine gc_testbbgc
  login <<< username >>>
  password <<< password >>>

   Here the `gc_' prefix to the profile name specifies clearly that
this is a Google account. Replace the `<<< >>>' with your actual values.

   Similarly for a CardDAV account credentials the `gc_' prefix will
become `cd_'. Like so:

machine cd_testbbcd
  login <<< username >>>
  password <<< password >>>

5.2.1 Using netrc for like-pair synching
----------------------------------------

If your profile is set up to sync betwen two like stores, for e.g.
between two Google Contacts accounts, you can specify the login
credentials in your netrc as follows:

machine gc1_testgcgc
  login <<< username >>>
  password <<< password >>>

machine gc2_testgcgc
  login <<< username >>>
  password <<< password >>>

   Note the name of the machine specifies if it belongs to the first or
second collection. Note that you could use the same credentials for both
collections. This case would be useful to copy / mirror contacts from
one folder to another.

6 Recipes
*********

Note to Self: This section ideally should only give examples without
really explaining the options, constraints  etc. in depth - that should
be done in the previous section on "Using ASynK" where the complete
documentation for every flag in the system will be documented, and will
the authoritative single reference for such things. This will entail
some reorg of the doc content and much additional content as well...

   The easiest way to get used to AsynK is to look at some examples.
This chapter contains some of the simplest use cases. You can refer to
section Using ASynK, for detailed documentation on
each flag, legal and illegal options, etc.

6.1 Basic Usage: using the default sync profiles
================================================

`$ ./asynk.py --op=sync [--dry-run] [--log=debug]'

   ASynK comes with two default profiles to help you get a quick feel
for the sync features.

   When you run the above mentioned command on a windows box a default
profile called `defolbb' kicks in and contacts in your  ~/.bbdb file are
bi-directionally synced to your default Outlook folder.

   On any non-windows platform, your ~/.bbdb is merely "synched" to
another BBDB file in /tmp/asynk.bbdb. The default profile that kicks in
is `defbbbb'

   Note: In earlier versions the default profiles helped you sync
easily to your Google account, but due to some changes that Google made
to its authentication flow, a simple no-frills sync is no longer
possible. Setting up Google sync is covered elsewhere in this
documentation.

6.2 Explore Folders and Create Synk Profile
===========================================

  1. Determine the PIMDBs you want to sync - i.e. select two from `bb',
     `gc', and `ol'

  2. Determine the Message Stores you want to sync - remember that for
     Google, a message store is an account with login credentials, for
     Outlook it maps to an Outlook MessageStore (IDs are obtained from
     a `--op=list-folders' command shown below), and for BBDB it is a
     file - specified by a filename. The Stores are specified with the
     `--store=<storeid, storeid>' option.

  3. List the folders you have in your Message Stores to identify the
     folders that actually contain the Items you want to synchronize.
     Cardassia:Gout sriramkarra$ python asynk.py --op=list-folders --db gc --store karra.etc < login.auth
     [18:08:08.216     INFO] Debug logging to file: /Users/sriramkarra/stuff/code/python/Gout/logs/asynk_logs.2012-05-09.18-08-08.216602
     [18:08:08.572     INFO] Logging into Google...
     [18:08:10.603     INFO] Listing all folders in PIMDB gc...
     [18:08:11.797     INFO]   0: Contacts Name: System Group: My Contacts ID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/6
     [18:08:11.797     INFO]   1: Contacts Name: System Group: Friends     ID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/d
     [18:08:11.797     INFO]   2: Contacts Name: System Group: Family      ID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/e
     [18:08:11.797     INFO]   3: Contacts Name: System Group: Coworkers   ID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/f
     [18:08:11.797     INFO]   4: Contacts Name: TestBB                    ID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/2fae451c0fe771d5
     [18:08:11.797     INFO]   5: Contacts Name: Gout                      ID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/41baff770f898d85
     [18:08:11.798     INFO]   6: Contacts Name: Starred in Android        ID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/5254f4a808c5e7d8
     [18:08:11.798     INFO] Listing all folders in PIMDB gc...done

     The output should be self explanatory. The group ID is the full
     URI in the last column of output. A few things to note:

       1. For a google sync profile operation, if a -store option is
          skipped, the user is prompted for a username and password
          from stdin. If a -store option is given on the command line,
          it is used as the login name and only the password is
          prompted for.

       2. In the above example, we have stored the password (in plain
          text) in a file called "login.auth" and piping it to ASynK.

     Cardassia:Gout sriramkarra$ ./asynk.py --op=list-folders --db bb --store test/bbdb.utah.ver7
     [18:27:07.147     INFO] Debug logging to file: /Users/sriramkarra/stuff/code/python/Gout/logs/asynk_logs.2012-05-09.18-27-07.147160
     [18:27:07.149     INFO] Parsing BBDB file /Users/sriramkarra/stuff/code/python/Gout/test/bbdb.utah.ver7...
     [18:27:07.396     INFO] Successfully parsed 338 entries.
     [18:27:07.396     INFO] Listing all folders in PIMDB bb...
     [18:27:07.396     INFO]   1: Contacts.	Name: default;	GID: default;
     [18:27:07.396     INFO] Listing all folders in PIMDB bb...done

     Here we passed the relative path of a BBDB file to list-folders.
     Recall that for BBBD the message store is the full BBDB file. In
     this instance the store is a typical BBDB database file where no
     contacts have the `folder' notes field, hence all of them are put
     in the "default" folder. Note how the name and ID of the folder
     are the same.
     TODO: Insert a sample Outlook list-folders

  4. Optionally you would like to create a folder in one of the Message
     Stores to hold your synchronized contacts. While you can create
     new folders in the native UI of Google Contacts or Outlook and use
     them with ASynK, we just provide a convenience option of creating
     one from the command line.
     Cardassia:Gout sriramkarra$ ./asynk.py --op create-folder --name 'Demo' --db gc --store karra.etc@gmail.com < login.auth
     [22:30:00.827     INFO] Debug logging to file: /Users/sriramkarra/stuff/code/python/Gout/logs/asynk_logs.2012-05-12.22-30-00.827089
     [22:30:00.829     INFO] Logging into Google...
     [22:30:02.871     INFO] Successfully created group. ID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/6c2034580ea2ac15

     Cardassia:Gout sriramkarra$ ./asynk.py --op=list-folders --db gc --store karra.etc < login.auth
     [22:30:08.870     INFO] Debug logging to file: /Users/sriramkarra/stuff/code/python/Gout/logs/asynk_logs.2012-05-12.22-30-08.870610
     [22:30:08.872     INFO] Logging into Google...
     [22:30:09.899     INFO] Listing all folders in PIMDB gc...
     [22:30:10.331     INFO]   0: Contacts Name: System Group: My Contacts ID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/6
     [22:30:10.332     INFO]   1: Contacts Name: System Group: Friends     ID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/d
     [22:30:10.332     INFO]   2: Contacts Name: System Group: Family      ID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/e
     [22:30:10.332     INFO]   3: Contacts Name: System Group: Coworkers   ID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/f
     [22:30:10.332     INFO]   4: Contacts Name: TestBB                    ID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/2fae451c0fe771d5
     [22:30:10.332     INFO]   5: Contacts Name: Gout                      ID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/41baff770f898d85
     [22:30:10.333     INFO]   6: Contacts Name: Starred in Android        ID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/5254f4a808c5e7d8
     [22:30:10.333     INFO]   7: Contacts Name: Demo                      ID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/6c2034580ea2ac15
     [22:30:10.333     INFO]   8: Contacts Name: For Testing OLGC          ID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/727ac1f9891121f7

     As we can see, the new folder has been created successfully.

  5. List your sync profiles. When you first start out, there is only a
     dummy sync profile, whose only purpose for existence is so you can
     do a list-profiles with your shiny new ASynK download :-) So let's
     do it.
     Creating default state.json to hold application status
     [22:35:00.058     INFO] Debug logging to file: /Users/sriramkarra/stuff/code/python/ASynK/logs/asynk_logs.2012-05-12.22-35-00.058672
     [22:35:00.060     INFO]
     [22:35:00.060     INFO] *** Profile   : sample ***
     [22:35:00.061     INFO]   Collection 1:
     [22:35:00.061     INFO]     DB ID     : gc
     [22:35:00.061     INFO]     Store ID  : karra.etc@gmail.com
     [22:35:00.061     INFO]     Folder ID : http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/2fae451c0fe771d5
     [22:35:00.062     INFO]   Collection 2:
     [22:35:00.062     INFO]     DB ID     : bb
     [22:35:00.062     INFO]     Store ID  : test/bbdb.utah.ver7
     [22:35:00.062     INFO]     Folder ID : default
     [22:35:00.062     INFO]   sync_start  : 1980-01-01T00:00:00.00+00:00
     [22:35:00.062     INFO]   sync_stop   : 1980-01-01T00:00:00.00+00:00
     [22:35:00.063     INFO]   sync_dir    : SYNC2WAY
     [22:35:00.063     INFO]   confl_res   : gc
     [22:35:00.063     INFO]   olgid       : 0x9001

     The output should be fairly self explanatory. The sample profile
     is between a GC folder and the default folder in a specific BBDB
     store. It also specifies that the sync should be two way, and You
     do not have to understand what "olgid" means. This is

  6. You would create up a sync profile that specifies the various
     details ASynK needs to know to perform a sync. (See section ASynK
     Profile). From here on your regular sync is done through a
     reference to the profile name, and you do not have to type out all
     the confusing IDs etc. every time.
     Cardassia:Gout sriramkarra$ python asynk.py --op=create-profile --db gc bb  \
     --folder 'http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/2fae451c0fe771d5' \
     'default' --store karra.etc 'test/bbdb.olbb' --name etcbb3
     [00:33:39.347     INFO] Debug logging to file: /Users/sriramkarra/stuff/code/python/Gout/logs/asynk_logs.2012-05-13.00-33-39.347515
     [00:33:39.373     INFO] Successfully added profile: etcbb3

     The `--op=create-profile' operation takes two dbids, two store ids
     and two folder ids. The command line is quite a handful, but you
     should not have to repeat this operation too often. It is worth
     noting the following about the options passed:

        * The order of values for the `--db', `--store' and `--folder'
          options is important and should be consistent - i.e. the
          first value from each of these three will be used as one
          collection, and second values are used as

        * If "gc" is one of the dbids, and store id is missing, it will
          be picked up from stdin.

        * If BBDB is one of the dbids and folder id is missing it is
          assumed to be the default folder.

        * If ol is one of the dbids and the store id is missing, we use
          the default message store in the default profile

     Cardassia:Gout sriramkarra$ python asynk.py --op=list-profiles
     [00:34:44.785     INFO] Debug logging to file: /Users/sriramkarra/stuff/code/python/Gout/logs/asynk_logs.2012-05-13.00-34-44.785442
     [00:34:44.787     INFO]
     [00:34:44.790     INFO] *** Profile   : etcbb3 ***
     [00:34:44.790     INFO]   Collection 1:
     [00:34:44.790     INFO]     DB ID     : gc
     [00:34:44.790     INFO]     Store ID  : karra.etc
     [00:34:44.790     INFO]     Folder ID : http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/2fae451c0fe771d5
     [00:34:44.791     INFO]   Collection 2:
     [00:34:44.791     INFO]     DB ID     : bb
     [00:34:44.791     INFO]     Store ID  : test/bbdb.olbb
     [00:34:44.791     INFO]     Folder ID : default
     [00:34:44.791     INFO]   sync_start  : 1980-01-01T00:00:00.00+00:00
     [00:34:44.791     INFO]   sync_stop   : 1980-01-01T00:00:00.00+00:00
     [00:34:44.791     INFO]   sync_dir    : SYNC2WAY
     [00:34:44.791     INFO]   confl_res   : gc
     [00:34:44.791     INFO]   olgid       : 0x0
     [00:34:44.792     INFO]
     [00:34:44.792     INFO] *** Profile   : sample ***
     [00:34:44.792     INFO]   Collection 1:
     [00:34:44.792     INFO]     DB ID     : gc
     [00:34:44.792     INFO]     Store ID  : karra.etc@gmail.com
     [00:34:44.792     INFO]     Folder ID : http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/3b83f70e88fa08bd
     [00:34:44.792     INFO]   Collection 2:
     [00:34:44.792     INFO]     DB ID     : ol
     [00:34:44.792     INFO]     Store ID  : None
     [00:34:44.792     INFO]     Folder ID : AAAAADWE5+lnNclLmn8GpZUD04eCRRoA
     [00:34:44.792     INFO]   sync_start  : 1980-01-01T00:00:00.00+00:00
     [00:34:44.793     INFO]   sync_stop   : 1980-01-01T00:00:00.00+00:00
     [00:34:44.793     INFO]   sync_dir    : SYNC2WAY
     [00:34:44.793     INFO]   confl_res   : gc
     [00:34:44.793     INFO]   olgid       : 0x9001

     And as we can confirm the new profile is now set up and available
     for use. Please note that there is not much error checking at the
     time of profile creation. For e.g. it is the user's responsibility
     to ensure there is a specified folder and store in a given pimdb,
     etc. If there are any errors, they will show up in subsequent sync
     operations.

6.3 Sync Actions and Related Cleanup
====================================

  1. Perform a "dry run" to get a sense of how many contacts are going
     to get copied from where to where.
     Cardassia:Gout sriramkarra$ python asynk.py --op=sync --dry-run --name etcbb2 < login.auth
     [00:53:10.643     INFO] Debug logging to file: /Users/sriramkarra/stuff/code/python/Gout/logs/asynk_logs.2012-05-13.00-53-10.643187
     [00:53:10.648     INFO] Logging into Google...
     [00:53:12.143     INFO] Parsing BBDB file /Users/sriramkarra/stuff/code/python/Gout/test/bbdb.utah.ver7...
     Password: [00:53:12.291     INFO] Successfully parsed 338 entries.
     [00:53:12.291     INFO] BBDB database not backed up for dry run
     [00:53:12.292     INFO] Last synk for profile etcbb2 was at: 2012-05-11T11:01:56.57Z
     [00:53:12.292     INFO] Querying Google for status of Contact Entries...
     [00:53:13.157     INFO] Response received from Google. Processing...
     [00:53:13.157     INFO] No entries in feed.
     [00:53:13.159     INFO] ==== gc =====
     [00:53:13.160     INFO]    New              :     0
     [00:53:13.160     INFO]    Modified         :     0
     [00:53:13.160     INFO]    Unchanged        :     0
     [00:53:13.160     INFO]                       =====
     [00:53:13.160     INFO]    Total Entries    :     0
     [00:53:13.160     INFO]    Deleted          :     0
     [00:53:13.160     INFO] ==== bb =====
     [00:53:13.161     INFO]    New              :     0
     [00:53:13.161     INFO]    Modified         :     0
     [00:53:13.161     INFO]    Unchanged        :   338
     [00:53:13.161     INFO]                       =====
     [00:53:13.161     INFO]    Total Entries    :   338
     [00:53:13.161     INFO]    Deleted          :     0
     [00:53:13.161     INFO] Number of entries modified both places (conflicts): 0
     [00:53:13.162     INFO] conflict resolve direction : bb. db1id: gc, db2id: bb
     [00:53:13.162     INFO] After conflict resolution, size of gc mod :     0
     [00:53:13.162     INFO] After conflict resolution, size of bb mod :     0

     It's not technically a complete dry run. For now we just get a
     summary of stats of what will happen during a proper sync. In the
     above run we see that there are no new entries or modifications at
     either end. Essentially if you perform a sync now, no entries need
     to be copied from anywhere to anywhere.

     Let's see one more example, this time with a sync profile
     containing an Outlook folder.
     Z:\Gout>python asynk.py --op=sync --name realolbb --dry-run
     [11:26:33.790     INFO] Debug logging to file: Z:\Gout\logs\asynk_logs.2012-05-13.11-26-33.791000
     [11:26:33.868     INFO] Parsing BBDB file Z:\Gout\test/bbdb.olbb...
     [11:26:33.930     INFO] Successfully parsed 0 entries.
     [11:26:33.930     INFO] Initalizing MAPI...
     [11:26:34.368     INFO] Initalizing MAPI...done
     [11:26:34.368     INFO] Opening default profile in MAPI...
     [11:26:34.476     INFO] Opening default profile in MAPI...done
     [11:26:34.789     INFO] Looking for PIM folders in message store: Personal Folders...
     [11:26:34.805     INFO] Appointments not supported. Ignoring.
     [11:26:34.944     INFO] Looking for PIM folders in message store: Personal Folders...done
     [11:26:35.256     INFO] Looking for PIM folders in message store: Master Task List...
     [11:26:35.273     INFO] Appointments not supported. Ignoring.
     [11:26:35.273     INFO] Appointments not supported. Ignoring.
     [11:26:35.647     INFO] Looking for PIM folders in message store: Master Task List...done
     [11:26:37.674     INFO] BBDB database not backed up for dry run
     [11:26:37.690     INFO] Last synk for profile realolbb was at: 2012-05-12T02:38:08.34Z
     [11:26:37.690     INFO] Querying MAPI for status of Contact Entries
     [11:26:37.706     INFO] Data obtained from MAPI. Processing...
     [11:26:37.706     INFO] ==== bb =====
     [11:26:37.706     INFO]    New              :     0
     [11:26:37.706     INFO]    Modified         :     0
     [11:26:37.706     INFO]    Unchanged        :     0
     [11:26:37.706     INFO]                       =====
     [11:26:37.706     INFO]    Total Entries    :     0
     [11:26:37.706     INFO]    Deleted          :     0
     [11:26:37.706     INFO] ==== ol =====
     [11:26:37.706     INFO]    New              :     2
     [11:26:37.706     INFO]    Modified         :     0
     [11:26:37.706     INFO]    Unchanged        :     0
     [11:26:37.721     INFO]                       =====
     [11:26:37.721     INFO]    Total Entries    :     2
     [11:26:37.721     INFO]    Deleted          :     0
     [11:26:37.721     INFO] Number of entries modified both places (conflicts): 0
     [11:26:37.721     INFO] conflict resolve direction : bb. db1id: bb, db2id: ol
     [11:26:37.721     INFO] After conflict resolution, size of bb mod :     0
     [11:26:37.721     INFO] After conflict resolution, size of ol mod :     0

  2. Perform the actual sync. Note that we do not provide a `--name'
     argument to specify the profile name. ASynK will remember the last
     profile that was operated on and use it in case a `--name' is not
     explicitly specified.
     Z:\Gout>python asynk.py --op=sync
     [11:26:56.769     INFO] Debug logging to file: Z:\Gout\logs\asynk_logs.2012-05-13.11-26-56.769000
     [11:26:56.769     INFO] Parsing BBDB file Z:\Gout\test/bbdb.olbb...
     [11:26:56.769     INFO] Successfully parsed 0 entries.
     [11:26:56.769     INFO] Initalizing MAPI...
     [11:26:57.144     INFO] Initalizing MAPI...done
     [11:26:57.144     INFO] Opening default profile in MAPI...
     [11:26:57.253     INFO] Opening default profile in MAPI...done
     [11:26:57.549     INFO] Looking for PIM folders in message store: Personal Folders...
     [11:26:57.579     INFO] Appointments not supported. Ignoring.
     [11:26:57.782     INFO] Looking for PIM folders in message store: Personal Folders...done
     [11:26:58.016     INFO] Looking for PIM folders in message store: Master Task List...
     [11:26:58.048     INFO] Appointments not supported. Ignoring.
     [11:26:58.063     INFO] Appointments not supported. Ignoring.
     [11:26:58.312     INFO] Looking for PIM folders in message store: Master Task List...done
     [11:27:00.591     INFO] Backedup BBDB Store (Z:\Gout\test/bbdb.olbb) to file: Z:\Gout\./backups\bbdb_backup.realolbb.2012-05-13.
     -27-00.591000
     [11:27:00.684     INFO] Last synk for profile realolbb was at: 2012-05-12T02:38:08.34Z
     [11:27:00.684     INFO] Querying MAPI for status of Contact Entries
     [11:27:00.684     INFO] Data obtained from MAPI. Processing...
     [11:27:00.684     INFO] ==== bb =====
     [11:27:00.684     INFO]    New              :     0
     [11:27:00.684     INFO]    Modified         :     0
     [11:27:00.684     INFO]    Unchanged        :     0
     [11:27:00.684     INFO]                       =====
     [11:27:00.716     INFO]    Total Entries    :     0
     [11:27:00.716     INFO]    Deleted          :     0
     [11:27:00.716     INFO] ==== ol =====
     [11:27:00.716     INFO]    New              :     2
     [11:27:00.716     INFO]    Modified         :     0
     [11:27:00.730     INFO]    Unchanged        :     0
     [11:27:00.730     INFO]                       =====
     [11:27:00.730     INFO]    Total Entries    :     2
     [11:27:00.730     INFO]    Deleted          :     0
     [11:27:00.730     INFO] Number of entries modified both places (conflicts): 0
     [11:27:00.730     INFO] conflict resolve direction : bb. db1id: bb, db2id: ol
     [11:27:00.730     INFO] After conflict resolution, size of bb mod :     0
     [11:27:00.730     INFO] After conflict resolution, size of ol mod :     0
     [11:27:00.730     INFO] =====================================================
     [11:27:00.730     INFO]    Sending New bb entries to ol
     [11:27:00.730     INFO] =====================================================
     [11:27:00.730     INFO] No new entries that need to be synched
     [11:27:00.730     INFO] =====================================================
     [11:27:00.730     INFO]    Sending Modified bb entries to ol
     [11:27:00.746     INFO] =====================================================
     [11:27:00.746     INFO] No modified entries that need to be synched
     [11:27:00.746     INFO] =====================================================
     [11:27:00.746     INFO]    Sending New ol entries to bb
     [11:27:00.746     INFO] =====================================================
     [11:27:00.746     INFO] 2 new entries to be synched.
     [11:27:00.809     INFO] Saving BBDB File Z:\Gout\test/bbdb.olbb...
     [11:27:00.809     INFO] =====================================================
     [11:27:00.996     INFO]    Sending Modified ol entries to bb
     [11:27:00.996     INFO] =====================================================
     [11:27:00.996     INFO] No modified entries that need to be synched

     We see that the output from a dry-run operation is repeated, and
     then the actual two way sync happens. Note the following:

       1. The BBDB file is backed up before any modifications are made.
          The location is echoed to the console as an INFO message. It
          is also captured in a log file as noted.

       2. If there are *any* errors during a sync operation, the
          timestamps are not updated, however some of the database
          entries may well have been made persistent, and it is not
          possible to roll back. In database terms, ASynK does not do
          transactional writes and roll backs. This could create
          problems if there are too many failures. It's a lot of work
          to change this behaviour. So let's study the problem in the
          field and take a call on how to tackle it.

6.4 Synching to CardDAV
=======================

Setting up a profile to sync with a CardDAV profile may be a bit
confusing at best, and downright intimidating at worst. Part of the
problem is the Store ID itself is a URL, and it is not a standard -
varying from one software to another.

   A reminder - CardDAV support is the newest feature in ASynK, and
there may be some rough edges. Also most CardDAV servers do not allow a
roll back - like Gmail does - to recover any lost data. So convince
yourself that ASynK will work for you before you start using it.

6.4.1 Creating a profile with CardDAV
-------------------------------------

   $ ./asynk.py --op=create-profile --name testbbcd --user-dir=~/.asynk.cd --db bb cd --folder default default --store <opath-to-bbdb-file> <CardDAV URL> --cduser=<username>

Ensure you are able to login to your account properly.

   $ ./asynk.py --op=sync --user-dir=~/.asynk.cd --name testbbcd --dry-run
   $ ./asynk.py --op=sync --user-dir=~/.asynk.cd --name testbbcd

6.4.1.1 CardDAV URL to use for the -store parameter
...................................................

The thing that confuses most people is the CardDAV url which is not in
any standard format. Here are some of the known CardDAV servers, and
the URL that usually works with them. Replace server.org with the name
of your CardDAV server. If your server is not to be found here, a good
way to search the internet for the URL to use is to use a software like
Addressbook in OS X; the same URL will work with ASynK as well.

  1. Apple CalendarServer: https://server.org:8443/ or
     http://server.org/

  2. OwnCloud: https://server.org/owncloud/remote.php/carddav

  3. Baikal Server: http://server.org/card.php

   Note that for the port number may be optional. If Apple
CalendarServer is configured to respond to both http and https the a
port number will be required. Check your server documentation.

6.4.1.2 CardDAV URL to use for the -folder parameter
....................................................

You can just use "default" as the folder ID. But if you feel like using
a specific folder, note that the foid parameter in your state.json
should look like the following for each of the tested CardDAV servers:

  1. Apple CalendarServer: /addressbooks/__uids__/skarrag/addressbook/

  2. OwnCloud:
     /owncloud/remote.php/carddav/addressbooks/skarra/contacts/

  3. Baikal Server: /card.php/addressbooks/skarra/default/

6.5 Synching to Microsoft Exchange
==================================

A reminder - Exchange support is the newest feature in ASynK, and there
may be some rough edges. We have taken care to ensure that any deletes
from the server move the contacts to the Trash Bin from where you can
recover items if something goes wrong. However convince yourself that
ASynK works fine before using it with your prodcution data.

6.5.1 Creating a profile with Exchange
--------------------------------------

   $ ./asynk.py --op=create-profile --name testbbex --db bb ex --folder default Contacts --store <opath-to-bbdb-file> <Exchange URL>

The Exchange URL is of the form:
https://outlook.office365.com/EWS/Exchange.asmx - you should ask your
system administrator.

   Ensure you are able to login to your account properly.

   $ ./asynk.py --op=sync --user-dir=~/.asynk.cd --name testbbcd --dry-run

   If everything works fine, you can try out without the dry-run option.

6.6 Misc Housekeeping Activities
================================

  1. _Clear Sync Flags from Contact Entries_. Recall that ASynK stores
     some tracking information (such as the contact's IDs in other
     remote folders) as custom user fields. These custom fields are
     readily viewable and editable in Google Contacts and BBDB, and as
     you can manually edit or delete them on a per contact basis, if
     you so desire (although it is most definitely _not recommended)_.
     MS Outlook, on the other hand, does not provide any reasonable way
     to view or manipulate these fields.

     ASynK provides an automated way to clear out sync related tags
     from a specified folder. It is best explained through a few
     examples. But before you should know that ASynK tracks IDs using
     properties with labels like: "asynk:profile:ol". There are three
     parts separated by a colon. The first part is always `asynk'. The
     middle portion is the name of the profile. The last portion is the
     PIMDB ID in whose ID we are tracking.

     The `--op=clear-sync-artifacts' operation takes a dbid
     (mandatory), a storeid and a folderid. If the storeid or folderid
     are missing ASynK tries to use defaults or query the user as per
     conventions explained earlier (TODO: insert ref). The final
     argument is the most interesting: it is a regular expression to
     match against the custom properties of contacts in the specified
     folder.
     Z:\Gout>python asynk.py --op=clear-sync-artifacts --db bb --store test/bbdb.olbb --label-re="asynk:realobb"
     [10:59:05.456     INFO] Debug logging to file: Z:\Gout\logs\asynk_logs.2012-05-13.10-59-05.456000
     [10:59:05.456     INFO] Parsing BBDB file Z:\Gout\test/bbdb.olbb...
     [10:59:05.456     INFO] Successfully parsed 20 entries.
     [10:59:05.470     INFO] Found 0 contacts with matching sync tag(s).
     [10:59:05.470     INFO] Saving BBDB File Z:\Gout\test/bbdb.olbb...

     In the above example, we try to delete any sync labels for the
     realolbb profile. The output shows that there were 20 entries in
     all, but nothing was really cleared out as there were no matches.
     Z:\Gout>python asynk.py --op=clear-sync-artifacts --db ol --folder "AAAAADWE5+lnNclLmn8GpZUD04ciRhoA" --label-re="asynk:"
     [11:08:42.651     INFO] Debug logging to file: Z:\Gout\logs\asynk_logs.2012-05-13.11-08-42.652000
     [11:08:42.667     INFO] Initalizing MAPI...
     [11:08:43.134     INFO] Initalizing MAPI...done
     [11:08:43.134     INFO] Opening default profile in MAPI...
     [11:08:43.275     INFO] Opening default profile in MAPI...done
     [11:08:43.602     INFO] Looking for PIM folders in message store: Personal Folders...
     [11:08:43.618     INFO] Appointments not supported. Ignoring.
     [11:08:43.836     INFO] Looking for PIM folders in message store: Personal Folders...done
     [11:08:44.101     INFO] Looking for PIM folders in message store: Master Task List...
     [11:08:44.101     INFO] Appointments not supported. Ignoring.
     [11:08:44.118     INFO] Appointments not supported. Ignoring.
     [11:08:44.710     INFO] Looking for PIM folders in message store: Master Task List...done
     [11:08:46.957     INFO] Querying MAPI for all data needed to clear flag
     [11:08:46.957     INFO] Data obtained from MAPI. Clearing one at a time
     [11:08:47.174     INFO] Entries cleared: 2. Errors: 0; i: 2

     In the above example we try to clear out all the sync tags in the
     specified outlook folder. The final line of output shows us that 2
     entries had ASynK sync tags, and they have been cleared out.

  2. _Delete a profile_
     Cardassia:Gout sriramkarra$ python asynk.py --op=del-profile  \
     --name etcbb3 < login.auth
     [11:45:09.153     INFO] Debug logging to file: /Users/sriramkarra/stuff/code/python/Gout/logs/asynk_logs.2012-05-13.11-45-09.153824
     [11:45:09.191     INFO] Logging into Google...
     [11:45:10.994     INFO] Parsing BBDB file /Users/sriramkarra/stuff/code/python/Gout/test/bbdb.olbb...
     Password: [11:45:11.073     INFO] Successfully parsed 2 entries.
     [11:45:11.073     INFO] Fetching contact entries from Google for folder TestBB...
     [11:45:14.310     INFO] Clearing sync state information...
     [11:45:14.313     INFO] Found 0 contacts with matching sync tag(s).
     [11:45:14.321     INFO] Found 0 contacts with matching sync tag(s).
     [11:45:14.322     INFO] Saving BBDB File /Users/sriramkarra/stuff/code/python/Gout/test/bbdb.olbb...
     [11:45:14.655     INFO] Successfully deleted the profile etcbb3 from your Asynk configuration.

     This does two things: remove the sync artifacts from both folders
     in the profile, and if there are no errors, remove the profile
     itself from the profile list.

  3. Show a summary of Items in a given folder. Currently implemented
     for Google Contacts, this the `--op=show-folder' operation can
     give you a one line summary of all contacts in google folder.
     Cardassia:Gout sriramkarra$ python asynk.py --op=show-folder --db gc \
     --store karra.etc --folder \
     "http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/2fae451c0fe771d5" \
      < login.auth
     [11:43:01.339     INFO] Debug logging to file: /Users/sriramkarra/stuff/code/python/Gout/logs/asynk_logs.2012-05-13.11-43-01.339125
     [11:43:01.389     INFO] Logging into Google...
     [11:43:03.330     INFO] Contacts.	Name: TestBB;	GID: http://www.google.com/m8/feeds/groups/karra.etc%40gmail.com/base/2fae451c0fe771d5;
     [11:43:03.330     INFO] Summary of contained Items:
     [11:43:06.318     INFO]   Name: Nicholas F. Cianfrocco    Itemid: https://www.google.com/m8/feeds/contacts/karra.etc%40gmail.com/full/86079960ff67a85
     [11:43:06.318     INFO]   Name: K. V. Krishna Kumar       Itemid: https://www.google.com/m8/feeds/contacts/karra.etc%40gmail.com/full/2ed62fa40b90b0bd
     [11:43:06.318     INFO]   Name: ASR Murthy                Itemid: https://www.google.com/m8/feeds/contacts/karra.etc%40gmail.com/full/6c856cd68dae99df
     [11:43:06.318     INFO]   Name: Ed Herring                Itemid: https://www.google.com/m8/feeds/contacts/karra.etc%40gmail.com/full/1041bce089860054
     [11:43:06.318     INFO]   Name: Parveen Kumar Patel       Itemid: https://www.google.com/m8/feeds/contacts/karra.etc%40gmail.com/full/360448d50a2c6bda
     [11:43:06.319     INFO]   Name: Ashwin M. Krishnakumar    Itemid: https://www.google.com/m8/feeds/contacts/karra.etc%40gmail.com/full/10bec2800bd7c9e7

     Here we get the name and Google ID of the contact for all contacts
     in the specified folder.

7 Internals
***********

7.1 Application and Sync State database: `state.json'
=====================================================

The profile database, and sync state is stored in a file called
`state.json', which is stored in ~/.asynk/ root directory of the
application. This file does not exist in the distribution, but is
created the very first time you run ASynK, from a file called
`state.init.json' in the root of the ASynK source directory.

   _Note for older ASynK users_: Before v0.3.0 ASynK could only be
executed from the root directory of ASynK source, and the configuration
files (state.json and config.json) were read and written there itself.
Starting with v0.3.0 ASynK can be invoked from any directory, and it
will start using ~/.asynk/ to read and write the configuration files.

   If you have been using ASynK before v0.3.0 and have a state.json
with your sync profiles and other configurations in the ASynK source
directory, you can migrate easily by just running ASynK from its root
directory once - ASynK will identify that you have some state and
config changes, and will copy your versions to ~/.asynk/ so they are
now available for subsequent runs from anywhere. Note, however, tha
once copied to ~/.asynk/ only the versions present there will be read
and written. Any changes you make to files elsewhere will not be
noticed.

7.2 Software Architecture
=========================

More to come here

8 FAQ
*****

Here are some Frequently Ask-able Questions, along with answers.

8.1 Can I use this to copy my contacts from one Google account to
=================================================================

another?  Yes, that is possible.

8.2 Is there a way to not use my CardDAV password in clear text?
================================================================

For now it is not possible. But please note that you are running ASynK
on your own machine. The authors of ASynK, or any one other than you
for that matter, cannot see your activity. That should provide some
comfort.

   Note that in the early days of ASynK, one had to use password in
clear text to sync from/to Google Contacts. Google themselves
deprecated this way of authentication, and now it is all oAuth-based.
It is a little more cumbersome to get set up in the new way, but it is
certainly more secure.

8.3 My Google password is not working, but I know it is right!
==============================================================

Circa late 2014 Google starting blocking access to applications
accessing account data using plain text authentication as a
conservative security policy. You can find more information about this
on Google's page here:
https://support.google.com/accounts/answer/6010255 and see if this is
what's tripping you up.

8.4 Other Comparable Tools
==========================

8.4.1 What's wrong with Google's tools?
---------------------------------------

Google's tools are not as versatile as ASynK. I started work on ASynK
because I was unhappy with the state of sync solutions for Android and
MS Outlook (more on this later). Subsequently I added BBDB support and
the made the application flexible enough that I can sync my contacts
between BBDB and MS Outlook directly. Google has no tools to do that,
of course. Further, the platform is flexible enough to add support for
any number of additional PIM data providers.

   Fundamentally, Google does not have a coherent and integrated
strategy for Personal Information Management (PIM). Contacts, Calendar,
Notes and Tasks are unrelated products with big differences in their
APIs. The Tasks program itself is of very limited functionality. This
applies equally to Android as well as for the cloud products. So it is
hardly surprising that they do not have a tightly integrated PIM sync
solution for Android like Blackberry and Nokia's sync software with MS
Outlook, say.

   Google does provide a few options for people who want to get data
into their Google account from Outlook.

  1. A two-way Contacts sync tool for customers of their 'Google Apps
     for Business users'. That is to say, it is not available for
     regular non-paying customers like you and me. I haven't tried this
     even once.

  2. A one-way migration Contacts migration tool from MS Outlook, which
     only works if you are saying goodbye to Outlook and moving home to
     Android. This is not practical for people who use Outlook at work,
     but who want to use their contacts on Android on their phone.

     Even if you're willing to keep all your edits in Outlook, there
     are various other problems:

        * It is so slow it is impractical for frequent use - migrating
          1000 contacts took more than 10 minutes. ASynK takes roughly
          a tenth of that time.

        * It is very inflexible: all contacts get dumped in your 'My
          Contacts' mother group. If you would like to neatly isolate
          your Outlook contacts neatly into a separate group, no go.

        * Older versions of this tool had issues with extracting email
          addresses from Outlook entries - EX email addresses for those
          who care. Incidentally, this EX email address problem plagues
          a number of sync solutions, including an otherwise excellent
          product from TouchDown for Outlook PST.

  3. A two-way Calendar sync tool that works quite well, and available
     for all users, include retail consumers.

  4. And finally, their import from CSV. Let's just say, if you're
     happy with this option you wouldn't be reading this right now.

8.4.2 What is wrong with tools from HTC and other vendors?
----------------------------------------------------------

These tools generally sync with MS Outlook, but are not available
easily for generic Android users. For e.g. owners of the pure Google
phones such as Nexus S. Further these are closed source, and adding
BBDB support is, well, not possible.

8.4.3 What is wrong with GoContactSync?
---------------------------------------

GoContactSync (`http://sourceforge.net/projects/gocontactsync' is a
GPL-ed two way sync solution between MS Outlook and Google Contacts. It
has favourable reviews on the general internet. The drawback is it is
written in .NET, a language I do not know and have no desire to learn
at this time. Python was versatile enough to work on Windows and Unix,
and allowed me to extend to a third PIM data provider (BBDB). As noted
earlier, ASynK is the only two way sync solution for BBDB today.

8.5 What's Changed between v0.1 and v0.2?
=========================================

It's almost a total rewrite. Here are main changes:

  1. v0.2.0 adds support for Emacs BBDB. At this time ASynK is the only
     available working program that does bidirectional sync of BBDB to
     any other PIM database.

  2. v0.1 was designed only for MS Outlook and Google Contacts. As a
     result it was designed to run on Windows only, and there is a
     mandatory dependency on PyWin32.

     v0.2 works on Linux, Mac and Windows. Only if MS Outlook support
     is needed, a third party library called PyWin32 is needed.

  3. v0.1 was distributed as a packaged Windows binary and the only
     user interface was a GUI built with WxPython (required the user to
     install an additional third party library)

     v0.2 UI is purely command line, even on Windows.

  4. v0.2 introduces the concept of sync profiles and folder-folder
     sync, which is much more advanced than what we had earlier. v0.1
     always did a sync between the default contacts folder in the
     default message store with a newly created folder called Gout on
     google.

Appendix A GNU AGPL
*******************

                      Version 3, 19 November 2007

     Copyright (C) 2007 Free Software Foundation, Inc. `http://fsf.org/'

     Everyone is permitted to copy and distribute verbatim copies of this
     license document, but changing it is not allowed.

Preamble
========

The GNU Affero General Public License is a free, copyleft license for
software and other kinds of works, specifically designed to ensure
cooperation with the community in the case of network server software.

   The licenses for most software and other practical works are
designed to take away your freedom to share and change the works.  By
contrast, our General Public Licenses are intended to guarantee your
freedom to share and change all versions of a program-to make sure it
remains free software for all its users.

   When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
them if you wish), that you receive source code or can get it if you
want it, that you can change the software or use pieces of it in new
free programs, and that you know you can do these things.

   Developers that use our General Public Licenses protect your rights
with two steps: (1) assert copyright on the software, and (2) offer you
this License which gives you legal permission to copy, distribute
and/or modify the software.

   A secondary benefit of defending all users' freedom is that
improvements made in alternate versions of the program, if they receive
widespread use, become available for other developers to incorporate.
Many developers of free software are heartened and encouraged by the
resulting cooperation.  However, in the case of software used on
network servers, this result may fail to come about.  The GNU General
Public License permits making a modified version and letting the public
access it on a server without ever releasing its source code to the
public.

   The GNU Affero General Public License is designed specifically to
ensure that, in such cases, the modified source code becomes available
to the community.  It requires the operator of a network server to
provide the source code of the modified version running there to the
users of that server.  Therefore, public use of a modified version, on
a publicly accessible server, gives the public access to the source
code of the modified version.

   An older license, called the Affero General Public License and
published by Affero, was designed to accomplish similar goals.  This is
a different license, not a version of the Affero GPL, but Affero has
released a new version of the Affero GPL which permits relicensing under
this license.

   The precise terms and conditions for copying, distribution and
modification follow.

TERMS AND CONDITIONS
====================

  0. Definitions.

     "This License" refers to version 3 of the GNU Affero General
     Public License.

     "Copyright" also means copyright-like laws that apply to other
     kinds of works, such as semiconductor masks.

     "The Program" refers to any copyrightable work licensed under this
     License.  Each licensee is addressed as "you".  "Licensees" and
     "recipients" may be individuals or organizations.

     To "modify" a work means to copy from or adapt all or part of the
     work in a fashion requiring copyright permission, other than the
     making of an exact copy.  The resulting work is called a "modified
     version" of the earlier work or a work "based on" the earlier work.

     A "covered work" means either the unmodified Program or a work
     based on the Program.

     To "propagate" a work means to do anything with it that, without
     permission, would make you directly or secondarily liable for
     infringement under applicable copyright law, except executing it
     on a computer or modifying a private copy.  Propagation includes
     copying, distribution (with or without modification), making
     available to the public, and in some countries other activities as
     well.

     To "convey" a work means any kind of propagation that enables other
     parties to make or receive copies.  Mere interaction with a user
     through a computer network, with no transfer of a copy, is not
     conveying.

     An interactive user interface displays "Appropriate Legal Notices"
     to the extent that it includes a convenient and prominently visible
     feature that (1) displays an appropriate copyright notice, and (2)
     tells the user that there is no warranty for the work (except to
     the extent that warranties are provided), that licensees may
     convey the work under this License, and how to view a copy of this
     License.  If the interface presents a list of user commands or
     options, such as a menu, a prominent item in the list meets this
     criterion.

  1. Source Code.

     The "source code" for a work means the preferred form of the work
     for making modifications to it.  "Object code" means any
     non-source form of a work.

     A "Standard Interface" means an interface that either is an
     official standard defined by a recognized standards body, or, in
     the case of interfaces specified for a particular programming
     language, one that is widely used among developers working in that
     language.

     The "System Libraries" of an executable work include anything,
     other than the work as a whole, that (a) is included in the normal
     form of packaging a Major Component, but which is not part of that
     Major Component, and (b) serves only to enable use of the work
     with that Major Component, or to implement a Standard Interface
     for which an implementation is available to the public in source
     code form.  A "Major Component", in this context, means a major
     essential component (kernel, window system, and so on) of the
     specific operating system (if any) on which the executable work
     runs, or a compiler used to produce the work, or an object code
     interpreter used to run it.

     The "Corresponding Source" for a work in object code form means all
     the source code needed to generate, install, and (for an executable
     work) run the object code and to modify the work, including
     scripts to control those activities.  However, it does not include
     the work's System Libraries, or general-purpose tools or generally
     available free programs which are used unmodified in performing
     those activities but which are not part of the work.  For example,
     Corresponding Source includes interface definition files
     associated with source files for the work, and the source code for
     shared libraries and dynamically linked subprograms that the work
     is specifically designed to require, such as by intimate data
     communication or control flow between those subprograms and other
     parts of the work.

     The Corresponding Source need not include anything that users can
     regenerate automatically from other parts of the Corresponding
     Source.

     The Corresponding Source for a work in source code form is that
     same work.

  2. Basic Permissions.

     All rights granted under this License are granted for the term of
     copyright on the Program, and are irrevocable provided the stated
     conditions are met.  This License explicitly affirms your unlimited
     permission to run the unmodified Program.  The output from running
     a covered work is covered by this License only if the output,
     given its content, constitutes a covered work.  This License
     acknowledges your rights of fair use or other equivalent, as
     provided by copyright law.

     You may make, run and propagate covered works that you do not
     convey, without conditions so long as your license otherwise
     remains in force.  You may convey covered works to others for the
     sole purpose of having them make modifications exclusively for
     you, or provide you with facilities for running those works,
     provided that you comply with the terms of this License in
     conveying all material for which you do not control copyright.
     Those thus making or running the covered works for you must do so
     exclusively on your behalf, under your direction and control, on
     terms that prohibit them from making any copies of your
     copyrighted material outside their relationship with you.

     Conveying under any other circumstances is permitted solely under
     the conditions stated below.  Sublicensing is not allowed; section
     10 makes it unnecessary.

  3. Protecting Users' Legal Rights From Anti-Circumvention Law.

     No covered work shall be deemed part of an effective technological
     measure under any applicable law fulfilling obligations under
     article 11 of the WIPO copyright treaty adopted on 20 December
     1996, or similar laws prohibiting or restricting circumvention of
     such measures.

     When you convey a covered work, you waive any legal power to forbid
     circumvention of technological measures to the extent such
     circumvention is effected by exercising rights under this License
     with respect to the covered work, and you disclaim any intention
     to limit operation or modification of the work as a means of
     enforcing, against the work's users, your or third parties' legal
     rights to forbid circumvention of technological measures.

  4. Conveying Verbatim Copies.

     You may convey verbatim copies of the Program's source code as you
     receive it, in any medium, provided that you conspicuously and
     appropriately publish on each copy an appropriate copyright notice;
     keep intact all notices stating that this License and any
     non-permissive terms added in accord with section 7 apply to the
     code; keep intact all notices of the absence of any warranty; and
     give all recipients a copy of this License along with the Program.

     You may charge any price or no price for each copy that you convey,
     and you may offer support or warranty protection for a fee.

  5. Conveying Modified Source Versions.

     You may convey a work based on the Program, or the modifications to
     produce it from the Program, in the form of source code under the
     terms of section 4, provided that you also meet all of these
     conditions:

       a. The work must carry prominent notices stating that you
          modified it, and giving a relevant date.

       b. The work must carry prominent notices stating that it is
          released under this License and any conditions added under
          section 7.  This requirement modifies the requirement in
          section 4 to "keep intact all notices".

       c. You must license the entire work, as a whole, under this
          License to anyone who comes into possession of a copy.  This
          License will therefore apply, along with any applicable
          section 7 additional terms, to the whole of the work, and all
          its parts, regardless of how they are packaged.  This License
          gives no permission to license the work in any other way, but
          it does not invalidate such permission if you have separately
          received it.

       d. If the work has interactive user interfaces, each must display
          Appropriate Legal Notices; however, if the Program has
          interactive interfaces that do not display Appropriate Legal
          Notices, your work need not make them do so.

     A compilation of a covered work with other separate and independent
     works, which are not by their nature extensions of the covered
     work, and which are not combined with it such as to form a larger
     program, in or on a volume of a storage or distribution medium, is
     called an "aggregate" if the compilation and its resulting
     copyright are not used to limit the access or legal rights of the
     compilation's users beyond what the individual works permit.
     Inclusion of a covered work in an aggregate does not cause this
     License to apply to the other parts of the aggregate.

  6. Conveying Non-Source Forms.

     You may convey a covered work in object code form under the terms
     of sections 4 and 5, provided that you also convey the
     machine-readable Corresponding Source under the terms of this
     License, in one of these ways:

       a. Convey the object code in, or embodied in, a physical product
          (including a physical distribution medium), accompanied by the
          Corresponding Source fixed on a durable physical medium
          customarily used for software interchange.

       b. Convey the object code in, or embodied in, a physical product
          (including a physical distribution medium), accompanied by a
          written offer, valid for at least three years and valid for
          as long as you offer spare parts or customer support for that
          product model, to give anyone who possesses the object code
          either (1) a copy of the Corresponding Source for all the
          software in the product that is covered by this License, on a
          durable physical medium customarily used for software
          interchange, for a price no more than your reasonable cost of
          physically performing this conveying of source, or (2) access
          to copy the Corresponding Source from a network server at no
          charge.

       c. Convey individual copies of the object code with a copy of
          the written offer to provide the Corresponding Source.  This
          alternative is allowed only occasionally and noncommercially,
          and only if you received the object code with such an offer,
          in accord with subsection 6b.

       d. Convey the object code by offering access from a designated
          place (gratis or for a charge), and offer equivalent access
          to the Corresponding Source in the same way through the same
          place at no further charge.  You need not require recipients
          to copy the Corresponding Source along with the object code.
          If the place to copy the object code is a network server, the
          Corresponding Source may be on a different server (operated
          by you or a third party) that supports equivalent copying
          facilities, provided you maintain clear directions next to
          the object code saying where to find the Corresponding Source.
          Regardless of what server hosts the Corresponding Source, you
          remain obligated to ensure that it is available for as long
          as needed to satisfy these requirements.

       e. Convey the object code using peer-to-peer transmission,
          provided you inform other peers where the object code and
          Corresponding Source of the work are being offered to the
          general public at no charge under subsection 6d.

     A separable portion of the object code, whose source code is
     excluded from the Corresponding Source as a System Library, need
     not be included in conveying the object code work.

     A "User Product" is either (1) a "consumer product", which means
     any tangible personal property which is normally used for personal,
     family, or household purposes, or (2) anything designed or sold for
     incorporation into a dwelling.  In determining whether a product
     is a consumer product, doubtful cases shall be resolved in favor of
     coverage.  For a particular product received by a particular user,
     "normally used" refers to a typical or common use of that class of
     product, regardless of the status of the particular user or of the
     way in which the particular user actually uses, or expects or is
     expected to use, the product.  A product is a consumer product
     regardless of whether the product has substantial commercial,
     industrial or non-consumer uses, unless such uses represent the
     only significant mode of use of the product.

     "Installation Information" for a User Product means any methods,
     procedures, authorization keys, or other information required to
     install and execute modified versions of a covered work in that
     User Product from a modified version of its Corresponding Source.
     The information must suffice to ensure that the continued
     functioning of the modified object code is in no case prevented or
     interfered with solely because modification has been made.

     If you convey an object code work under this section in, or with,
     or specifically for use in, a User Product, and the conveying
     occurs as part of a transaction in which the right of possession
     and use of the User Product is transferred to the recipient in
     perpetuity or for a fixed term (regardless of how the transaction
     is characterized), the Corresponding Source conveyed under this
     section must be accompanied by the Installation Information.  But
     this requirement does not apply if neither you nor any third party
     retains the ability to install modified object code on the User
     Product (for example, the work has been installed in ROM).

     The requirement to provide Installation Information does not
     include a requirement to continue to provide support service,
     warranty, or updates for a work that has been modified or
     installed by the recipient, or for the User Product in which it
     has been modified or installed.  Access to a network may be denied
     when the modification itself materially and adversely affects the
     operation of the network or violates the rules and protocols for
     communication across the network.

     Corresponding Source conveyed, and Installation Information
     provided, in accord with this section must be in a format that is
     publicly documented (and with an implementation available to the
     public in source code form), and must require no special password
     or key for unpacking, reading or copying.

  7. Additional Terms.

     "Additional permissions" are terms that supplement the terms of
     this License by making exceptions from one or more of its
     conditions.  Additional permissions that are applicable to the
     entire Program shall be treated as though they were included in
     this License, to the extent that they are valid under applicable
     law.  If additional permissions apply only to part of the Program,
     that part may be used separately under those permissions, but the
     entire Program remains governed by this License without regard to
     the additional permissions.

     When you convey a copy of a covered work, you may at your option
     remove any additional permissions from that copy, or from any part
     of it.  (Additional permissions may be written to require their own
     removal in certain cases when you modify the work.)  You may place
     additional permissions on material, added by you to a covered work,
     for which you have or can give appropriate copyright permission.

     Notwithstanding any other provision of this License, for material
     you add to a covered work, you may (if authorized by the copyright
     holders of that material) supplement the terms of this License
     with terms:

       a. Disclaiming warranty or limiting liability differently from
          the terms of sections 15 and 16 of this License; or

       b. Requiring preservation of specified reasonable legal notices
          or author attributions in that material or in the Appropriate
          Legal Notices displayed by works containing it; or

       c. Prohibiting misrepresentation of the origin of that material,
          or requiring that modified versions of such material be
          marked in reasonable ways as different from the original
          version; or

       d. Limiting the use for publicity purposes of names of licensors
          or authors of the material; or

       e. Declining to grant rights under trademark law for use of some
          trade names, trademarks, or service marks; or

       f. Requiring indemnification of licensors and authors of that
          material by anyone who conveys the material (or modified
          versions of it) with contractual assumptions of liability to
          the recipient, for any liability that these contractual
          assumptions directly impose on those licensors and authors.

     All other non-permissive additional terms are considered "further
     restrictions" within the meaning of section 10.  If the Program as
     you received it, or any part of it, contains a notice stating that
     it is governed by this License along with a term that is a further
     restriction, you may remove that term.  If a license document
     contains a further restriction but permits relicensing or
     conveying under this License, you may add to a covered work
     material governed by the terms of that license document, provided
     that the further restriction does not survive such relicensing or
     conveying.

     If you add terms to a covered work in accord with this section, you
     must place, in the relevant source files, a statement of the
     additional terms that apply to those files, or a notice indicating
     where to find the applicable terms.

     Additional terms, permissive or non-permissive, may be stated in
     the form of a separately written license, or stated as exceptions;
     the above requirements apply either way.

  8. Termination.

     You may not propagate or modify a covered work except as expressly
     provided under this License.  Any attempt otherwise to propagate or
     modify it is void, and will automatically terminate your rights
     under this License (including any patent licenses granted under
     the third paragraph of section 11).

     However, if you cease all violation of this License, then your
     license from a particular copyright holder is reinstated (a)
     provisionally, unless and until the copyright holder explicitly
     and finally terminates your license, and (b) permanently, if the
     copyright holder fails to notify you of the violation by some
     reasonable means prior to 60 days after the cessation.

     Moreover, your license from a particular copyright holder is
     reinstated permanently if the copyright holder notifies you of the
     violation by some reasonable means, this is the first time you have
     received notice of violation of this License (for any work) from
     that copyright holder, and you cure the violation prior to 30 days
     after your receipt of the notice.

     Termination of your rights under this section does not terminate
     the licenses of parties who have received copies or rights from
     you under this License.  If your rights have been terminated and
     not permanently reinstated, you do not qualify to receive new
     licenses for the same material under section 10.

  9. Acceptance Not Required for Having Copies.

     You are not required to accept this License in order to receive or
     run a copy of the Program.  Ancillary propagation of a covered work
     occurring solely as a consequence of using peer-to-peer
     transmission to receive a copy likewise does not require
     acceptance.  However, nothing other than this License grants you
     permission to propagate or modify any covered work.  These actions
     infringe copyright if you do not accept this License.  Therefore,
     by modifying or propagating a covered work, you indicate your
     acceptance of this License to do so.

 10. Automatic Licensing of Downstream Recipients.

     Each time you convey a covered work, the recipient automatically
     receives a license from the original licensors, to run, modify and
     propagate that work, subject to this License.  You are not
     responsible for enforcing compliance by third parties with this
     License.

     An "entity transaction" is a transaction transferring control of an
     organization, or substantially all assets of one, or subdividing an
     organization, or merging organizations.  If propagation of a
     covered work results from an entity transaction, each party to that
     transaction who receives a copy of the work also receives whatever
     licenses to the work the party's predecessor in interest had or
     could give under the previous paragraph, plus a right to
     possession of the Corresponding Source of the work from the
     predecessor in interest, if the predecessor has it or can get it
     with reasonable efforts.

     You may not impose any further restrictions on the exercise of the
     rights granted or affirmed under this License.  For example, you
     may not impose a license fee, royalty, or other charge for
     exercise of rights granted under this License, and you may not
     initiate litigation (including a cross-claim or counterclaim in a
     lawsuit) alleging that any patent claim is infringed by making,
     using, selling, offering for sale, or importing the Program or any
     portion of it.

 11. Patents.

     A "contributor" is a copyright holder who authorizes use under this
     License of the Program or a work on which the Program is based.
     The work thus licensed is called the contributor's "contributor
     version".

     A contributor's "essential patent claims" are all patent claims
     owned or controlled by the contributor, whether already acquired or
     hereafter acquired, that would be infringed by some manner,
     permitted by this License, of making, using, or selling its
     contributor version, but do not include claims that would be
     infringed only as a consequence of further modification of the
     contributor version.  For purposes of this definition, "control"
     includes the right to grant patent sublicenses in a manner
     consistent with the requirements of this License.

     Each contributor grants you a non-exclusive, worldwide,
     royalty-free patent license under the contributor's essential
     patent claims, to make, use, sell, offer for sale, import and
     otherwise run, modify and propagate the contents of its
     contributor version.

     In the following three paragraphs, a "patent license" is any
     express agreement or commitment, however denominated, not to
     enforce a patent (such as an express permission to practice a
     patent or covenant not to sue for patent infringement).  To
     "grant" such a patent license to a party means to make such an
     agreement or commitment not to enforce a patent against the party.

     If you convey a covered work, knowingly relying on a patent
     license, and the Corresponding Source of the work is not available
     for anyone to copy, free of charge and under the terms of this
     License, through a publicly available network server or other
     readily accessible means, then you must either (1) cause the
     Corresponding Source to be so available, or (2) arrange to deprive
     yourself of the benefit of the patent license for this particular
     work, or (3) arrange, in a manner consistent with the requirements
     of this License, to extend the patent license to downstream
     recipients.  "Knowingly relying" means you have actual knowledge
     that, but for the patent license, your conveying the covered work
     in a country, or your recipient's use of the covered work in a
     country, would infringe one or more identifiable patents in that
     country that you have reason to believe are valid.

     If, pursuant to or in connection with a single transaction or
     arrangement, you convey, or propagate by procuring conveyance of, a
     covered work, and grant a patent license to some of the parties
     receiving the covered work authorizing them to use, propagate,
     modify or convey a specific copy of the covered work, then the
     patent license you grant is automatically extended to all
     recipients of the covered work and works based on it.

     A patent license is "discriminatory" if it does not include within
     the scope of its coverage, prohibits the exercise of, or is
     conditioned on the non-exercise of one or more of the rights that
     are specifically granted under this License.  You may not convey a
     covered work if you are a party to an arrangement with a third
     party that is in the business of distributing software, under
     which you make payment to the third party based on the extent of
     your activity of conveying the work, and under which the third
     party grants, to any of the parties who would receive the covered
     work from you, a discriminatory patent license (a) in connection
     with copies of the covered work conveyed by you (or copies made
     from those copies), or (b) primarily for and in connection with
     specific products or compilations that contain the covered work,
     unless you entered into that arrangement, or that patent license
     was granted, prior to 28 March 2007.

     Nothing in this License shall be construed as excluding or limiting
     any implied license or other defenses to infringement that may
     otherwise be available to you under applicable patent law.

 12. No Surrender of Others' Freedom.

     If conditions are imposed on you (whether by court order,
     agreement or otherwise) that contradict the conditions of this
     License, they do not excuse you from the conditions of this
     License.  If you cannot convey a covered work so as to satisfy
     simultaneously your obligations under this License and any other
     pertinent obligations, then as a consequence you may not convey it
     at all.  For example, if you agree to terms that obligate you to
     collect a royalty for further conveying from those to whom you
     convey the Program, the only way you could satisfy both those
     terms and this License would be to refrain entirely from conveying
     the Program.

 13. Remote Network Interaction; Use with the GNU General Public
     License.

     Notwithstanding any other provision of this License, if you modify
     the Program, your modified version must prominently offer all
     users interacting with it remotely through a computer network (if
     your version supports such interaction) an opportunity to receive
     the Corresponding Source of your version by providing access to
     the Corresponding Source from a network server at no charge,
     through some standard or customary means of facilitating copying
     of software.  This Corresponding Source shall include the
     Corresponding Source for any work covered by version 3 of the GNU
     General Public License that is incorporated pursuant to the
     following paragraph.

     Notwithstanding any other provision of this License, you have
     permission to link or combine any covered work with a work
     licensed under version 3 of the GNU General Public License into a
     single combined work, and to convey the resulting work.  The terms
     of this License will continue to apply to the part which is the
     covered work, but the work with which it is combined will remain
     governed by version 3 of the GNU General Public License.

 14. Revised Versions of this License.

     The Free Software Foundation may publish revised and/or new
     versions of the GNU Affero General Public License from time to
     time.  Such new versions will be similar in spirit to the present
     version, but may differ in detail to address new problems or
     concerns.

     Each version is given a distinguishing version number.  If the
     Program specifies that a certain numbered version of the GNU
     Affero General Public License "or any later version" applies to
     it, you have the option of following the terms and conditions
     either of that numbered version or of any later version published
     by the Free Software Foundation.  If the Program does not specify
     a version number of the GNU Affero General Public License, you may
     choose any version ever published by the Free Software Foundation.

     If the Program specifies that a proxy can decide which future
     versions of the GNU Affero General Public License can be used,
     that proxy's public statement of acceptance of a version
     permanently authorizes you to choose that version for the Program.

     Later license versions may give you additional or different
     permissions.  However, no additional obligations are imposed on any
     author or copyright holder as a result of your choosing to follow a
     later version.

 15. Disclaimer of Warranty.

     THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
     APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE
     COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS"
     WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
     INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE
     RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.
     SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL
     NECESSARY SERVICING, REPAIR OR CORRECTION.

 16. Limitation of Liability.

     IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
     WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
     AND/OR CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU
     FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
     CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE
     THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA
     BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
     PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
     PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF
     THE POSSIBILITY OF SUCH DAMAGES.

 17. Interpretation of Sections 15 and 16.

     If the disclaimer of warranty and limitation of liability provided
     above cannot be given local legal effect according to their terms,
     reviewing courts shall apply local law that most closely
     approximates an absolute waiver of all civil liability in
     connection with the Program, unless a warranty or assumption of
     liability accompanies a copy of the Program in return for a fee.

END OF TERMS AND CONDITIONS
===========================

How to Apply These Terms to Your New Programs
=============================================

If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these
terms.

   To do so, attach the following notices to the program.  It is safest
to attach them to the start of each source file to most effectively
state the exclusion of warranty; and each file should have at least the
"copyright" line and a pointer to where the full notice is found.

     ONE LINE TO GIVE THE PROGRAM'S NAME AND A BRIEF IDEA OF WHAT IT DOES.
     Copyright (C) YEAR NAME OF AUTHOR

     This program is free software: you can redistribute it and/or modify
     it under the terms of the GNU Affero General Public License as published by
     the Free Software Foundation, either version 3 of the License, or (at
     your option) any later version.

     This program is distributed in the hope that it will be useful, but
     WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     Affero General Public License for more details.

     You should have received a copy of the GNU Affero General Public License
     along with this program.  If not, see `http://www.gnu.org/licenses/'.

   Also add information on how to contact you by electronic and paper
mail.

   If your software can interact with users remotely through a computer
network, you should also make sure that it provides a way for users to
get its source.  For example, if your program is a web application, its
interface could display a "Source" link that leads users to an archive
of the code.  There are many ways you could offer source, and different
solutions will be better for different programs; see section 13 for the
specific requirements.

   You should also get your employer (if you work as a programmer) or
school, if any, to sign a "copyright disclaimer" for the program, if
necessary.  For more information on this, and how to apply and follow
the GNU AGPL, see `http://www.gnu.org/licenses/'.

Appendix B GNU FDL
******************

                     Version 1.3, 3 November 2008

     Copyright (C) 2000, 2001, 2002, 2007, 2008, 2009 Free Software Foundation, Inc.
     `http://fsf.org/'

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

  0. PREAMBLE

     The purpose of this License is to make a manual, textbook, or other
     functional and useful document "free" in the sense of freedom: to
     assure everyone the effective freedom to copy and redistribute it,
     with or without modifying it, either commercially or
     noncommercially.  Secondarily, this License preserves for the
     author and publisher a way to get credit for their work, while not
     being considered responsible for modifications made by others.

     This License is a kind of "copyleft", which means that derivative
     works of the document must themselves be free in the same sense.
     It complements the GNU General Public License, which is a copyleft
     license designed for free software.

     We have designed this License in order to use it for manuals for
     free software, because free software needs free documentation: a
     free program should come with manuals providing the same freedoms
     that the software does.  But this License is not limited to
     software manuals; it can be used for any textual work, regardless
     of subject matter or whether it is published as a printed book.
     We recommend this License principally for works whose purpose is
     instruction or reference.

  1. APPLICABILITY AND DEFINITIONS

     This License applies to any manual or other work, in any medium,
     that contains a notice placed by the copyright holder saying it
     can be distributed under the terms of this License.  Such a notice
     grants a world-wide, royalty-free license, unlimited in duration,
     to use that work under the conditions stated herein.  The
     "Document", below, refers to any such manual or work.  Any member
     of the public is a licensee, and is addressed as "you".  You
     accept the license if you copy, modify or distribute the work in a
     way requiring permission under copyright law.

     A "Modified Version" of the Document means any work containing the
     Document or a portion of it, either copied verbatim, or with
     modifications and/or translated into another language.

     A "Secondary Section" is a named appendix or a front-matter section
     of the Document that deals exclusively with the relationship of the
     publishers or authors of the Document to the Document's overall
     subject (or to related matters) and contains nothing that could
     fall directly within that overall subject.  (Thus, if the Document
     is in part a textbook of mathematics, a Secondary Section may not
     explain any mathematics.)  The relationship could be a matter of
     historical connection with the subject or with related matters, or
     of legal, commercial, philosophical, ethical or political position
     regarding them.

     The "Invariant Sections" are certain Secondary Sections whose
     titles are designated, as being those of Invariant Sections, in
     the notice that says that the Document is released under this
     License.  If a section does not fit the above definition of
     Secondary then it is not allowed to be designated as Invariant.
     The Document may contain zero Invariant Sections.  If the Document
     does not identify any Invariant Sections then there are none.

     The "Cover Texts" are certain short passages of text that are
     listed, as Front-Cover Texts or Back-Cover Texts, in the notice
     that says that the Document is released under this License.  A
     Front-Cover Text may be at most 5 words, and a Back-Cover Text may
     be at most 25 words.

     A "Transparent" copy of the Document means a machine-readable copy,
     represented in a format whose specification is available to the
     general public, that is suitable for revising the document
     straightforwardly with generic text editors or (for images
     composed of pixels) generic paint programs or (for drawings) some
     widely available drawing editor, and that is suitable for input to
     text formatters or for automatic translation to a variety of
     formats suitable for input to text formatters.  A copy made in an
     otherwise Transparent file format whose markup, or absence of
     markup, has been arranged to thwart or discourage subsequent
     modification by readers is not Transparent.  An image format is
     not Transparent if used for any substantial amount of text.  A
     copy that is not "Transparent" is called "Opaque".

     Examples of suitable formats for Transparent copies include plain
     ASCII without markup, Texinfo input format, LaTeX input format,
     SGML or XML using a publicly available DTD, and
     standard-conforming simple HTML, PostScript or PDF designed for
     human modification.  Examples of transparent image formats include
     PNG, XCF and JPG.  Opaque formats include proprietary formats that
     can be read and edited only by proprietary word processors, SGML or
     XML for which the DTD and/or processing tools are not generally
     available, and the machine-generated HTML, PostScript or PDF
     produced by some word processors for output purposes only.

     The "Title Page" means, for a printed book, the title page itself,
     plus such following pages as are needed to hold, legibly, the
     material this License requires to appear in the title page.  For
     works in formats which do not have any title page as such, "Title
     Page" means the text near the most prominent appearance of the
     work's title, preceding the beginning of the body of the text.

     The "publisher" means any person or entity that distributes copies
     of the Document to the public.

     A section "Entitled XYZ" means a named subunit of the Document
     whose title either is precisely XYZ or contains XYZ in parentheses
     following text that translates XYZ in another language.  (Here XYZ
     stands for a specific section name mentioned below, such as
     "Acknowledgements", "Dedications", "Endorsements", or "History".)
     To "Preserve the Title" of such a section when you modify the
     Document means that it remains a section "Entitled XYZ" according
     to this definition.

     The Document may include Warranty Disclaimers next to the notice
     which states that this License applies to the Document.  These
     Warranty Disclaimers are considered to be included by reference in
     this License, but only as regards disclaiming warranties: any other
     implication that these Warranty Disclaimers may have is void and
     has no effect on the meaning of this License.

  2. VERBATIM COPYING

     You may copy and distribute the Document in any medium, either
     commercially or noncommercially, provided that this License, the
     copyright notices, and the license notice saying this License
     applies to the Document are reproduced in all copies, and that you
     add no other conditions whatsoever to those of this License.  You
     may not use technical measures to obstruct or control the reading
     or further copying of the copies you make or distribute.  However,
     you may accept compensation in exchange for copies.  If you
     distribute a large enough number of copies you must also follow
     the conditions in section 3.

     You may also lend copies, under the same conditions stated above,
     and you may publicly display copies.

  3. COPYING IN QUANTITY

     If you publish printed copies (or copies in media that commonly
     have printed covers) of the Document, numbering more than 100, and
     the Document's license notice requires Cover Texts, you must
     enclose the copies in covers that carry, clearly and legibly, all
     these Cover Texts: Front-Cover Texts on the front cover, and
     Back-Cover Texts on the back cover.  Both covers must also clearly
     and legibly identify you as the publisher of these copies.  The
     front cover must present the full title with all words of the
     title equally prominent and visible.  You may add other material
     on the covers in addition.  Copying with changes limited to the
     covers, as long as they preserve the title of the Document and
     satisfy these conditions, can be treated as verbatim copying in
     other respects.

     If the required texts for either cover are too voluminous to fit
     legibly, you should put the first ones listed (as many as fit
     reasonably) on the actual cover, and continue the rest onto
     adjacent pages.

     If you publish or distribute Opaque copies of the Document
     numbering more than 100, you must either include a
     machine-readable Transparent copy along with each Opaque copy, or
     state in or with each Opaque copy a computer-network location from
     which the general network-using public has access to download
     using public-standard network protocols a complete Transparent
     copy of the Document, free of added material.  If you use the
     latter option, you must take reasonably prudent steps, when you
     begin distribution of Opaque copies in quantity, to ensure that
     this Transparent copy will remain thus accessible at the stated
     location until at least one year after the last time you
     distribute an Opaque copy (directly or through your agents or
     retailers) of that edition to the public.

     It is requested, but not required, that you contact the authors of
     the Document well before redistributing any large number of
     copies, to give them a chance to provide you with an updated
     version of the Document.

  4. MODIFICATIONS

     You may copy and distribute a Modified Version of the Document
     under the conditions of sections 2 and 3 above, provided that you
     release the Modified Version under precisely this License, with
     the Modified Version filling the role of the Document, thus
     licensing distribution and modification of the Modified Version to
     whoever possesses a copy of it.  In addition, you must do these
     things in the Modified Version:

       A. Use in the Title Page (and on the covers, if any) a title
          distinct from that of the Document, and from those of
          previous versions (which should, if there were any, be listed
          in the History section of the Document).  You may use the
          same title as a previous version if the original publisher of
          that version gives permission.

       B. List on the Title Page, as authors, one or more persons or
          entities responsible for authorship of the modifications in
          the Modified Version, together with at least five of the
          principal authors of the Document (all of its principal
          authors, if it has fewer than five), unless they release you
          from this requirement.

       C. State on the Title page the name of the publisher of the
          Modified Version, as the publisher.

       D. Preserve all the copyright notices of the Document.

       E. Add an appropriate copyright notice for your modifications
          adjacent to the other copyright notices.

       F. Include, immediately after the copyright notices, a license
          notice giving the public permission to use the Modified
          Version under the terms of this License, in the form shown in
          the Addendum below.

       G. Preserve in that license notice the full lists of Invariant
          Sections and required Cover Texts given in the Document's
          license notice.

       H. Include an unaltered copy of this License.

       I. Preserve the section Entitled "History", Preserve its Title,
          and add to it an item stating at least the title, year, new
          authors, and publisher of the Modified Version as given on
          the Title Page.  If there is no section Entitled "History" in
          the Document, create one stating the title, year, authors,
          and publisher of the Document as given on its Title Page,
          then add an item describing the Modified Version as stated in
          the previous sentence.

       J. Preserve the network location, if any, given in the Document
          for public access to a Transparent copy of the Document, and
          likewise the network locations given in the Document for
          previous versions it was based on.  These may be placed in
          the "History" section.  You may omit a network location for a
          work that was published at least four years before the
          Document itself, or if the original publisher of the version
          it refers to gives permission.

       K. For any section Entitled "Acknowledgements" or "Dedications",
          Preserve the Title of the section, and preserve in the
          section all the substance and tone of each of the contributor
          acknowledgements and/or dedications given therein.

       L. Preserve all the Invariant Sections of the Document,
          unaltered in their text and in their titles.  Section numbers
          or the equivalent are not considered part of the section
          titles.

       M. Delete any section Entitled "Endorsements".  Such a section
          may not be included in the Modified Version.

       N. Do not retitle any existing section to be Entitled
          "Endorsements" or to conflict in title with any Invariant
          Section.

       O. Preserve any Warranty Disclaimers.

     If the Modified Version includes new front-matter sections or
     appendices that qualify as Secondary Sections and contain no
     material copied from the Document, you may at your option
     designate some or all of these sections as invariant.  To do this,
     add their titles to the list of Invariant Sections in the Modified
     Version's license notice.  These titles must be distinct from any
     other section titles.

     You may add a section Entitled "Endorsements", provided it contains
     nothing but endorsements of your Modified Version by various
     parties--for example, statements of peer review or that the text
     has been approved by an organization as the authoritative
     definition of a standard.

     You may add a passage of up to five words as a Front-Cover Text,
     and a passage of up to 25 words as a Back-Cover Text, to the end
     of the list of Cover Texts in the Modified Version.  Only one
     passage of Front-Cover Text and one of Back-Cover Text may be
     added by (or through arrangements made by) any one entity.  If the
     Document already includes a cover text for the same cover,
     previously added by you or by arrangement made by the same entity
     you are acting on behalf of, you may not add another; but you may
     replace the old one, on explicit permission from the previous
     publisher that added the old one.

     The author(s) and publisher(s) of the Document do not by this
     License give permission to use their names for publicity for or to
     assert or imply endorsement of any Modified Version.

  5. COMBINING DOCUMENTS

     You may combine the Document with other documents released under
     this License, under the terms defined in section 4 above for
     modified versions, provided that you include in the combination
     all of the Invariant Sections of all of the original documents,
     unmodified, and list them all as Invariant Sections of your
     combined work in its license notice, and that you preserve all
     their Warranty Disclaimers.

     The combined work need only contain one copy of this License, and
     multiple identical Invariant Sections may be replaced with a single
     copy.  If there are multiple Invariant Sections with the same name
     but different contents, make the title of each such section unique
     by adding at the end of it, in parentheses, the name of the
     original author or publisher of that section if known, or else a
     unique number.  Make the same adjustment to the section titles in
     the list of Invariant Sections in the license notice of the
     combined work.

     In the combination, you must combine any sections Entitled
     "History" in the various original documents, forming one section
     Entitled "History"; likewise combine any sections Entitled
     "Acknowledgements", and any sections Entitled "Dedications".  You
     must delete all sections Entitled "Endorsements."

  6. COLLECTIONS OF DOCUMENTS

     You may make a collection consisting of the Document and other
     documents released under this License, and replace the individual
     copies of this License in the various documents with a single copy
     that is included in the collection, provided that you follow the
     rules of this License for verbatim copying of each of the
     documents in all other respects.

     You may extract a single document from such a collection, and
     distribute it individually under this License, provided you insert
     a copy of this License into the extracted document, and follow
     this License in all other respects regarding verbatim copying of
     that document.

  7. AGGREGATION WITH INDEPENDENT WORKS

     A compilation of the Document or its derivatives with other
     separate and independent documents or works, in or on a volume of
     a storage or distribution medium, is called an "aggregate" if the
     copyright resulting from the compilation is not used to limit the
     legal rights of the compilation's users beyond what the individual
     works permit.  When the Document is included in an aggregate, this
     License does not apply to the other works in the aggregate which
     are not themselves derivative works of the Document.

     If the Cover Text requirement of section 3 is applicable to these
     copies of the Document, then if the Document is less than one half
     of the entire aggregate, the Document's Cover Texts may be placed
     on covers that bracket the Document within the aggregate, or the
     electronic equivalent of covers if the Document is in electronic
     form.  Otherwise they must appear on printed covers that bracket
     the whole aggregate.

  8. TRANSLATION

     Translation is considered a kind of modification, so you may
     distribute translations of the Document under the terms of section
     4.  Replacing Invariant Sections with translations requires special
     permission from their copyright holders, but you may include
     translations of some or all Invariant Sections in addition to the
     original versions of these Invariant Sections.  You may include a
     translation of this License, and all the license notices in the
     Document, and any Warranty Disclaimers, provided that you also
     include the original English version of this License and the
     original versions of those notices and disclaimers.  In case of a
     disagreement between the translation and the original version of
     this License or a notice or disclaimer, the original version will
     prevail.

     If a section in the Document is Entitled "Acknowledgements",
     "Dedications", or "History", the requirement (section 4) to
     Preserve its Title (section 1) will typically require changing the
     actual title.

  9. TERMINATION

     You may not copy, modify, sublicense, or distribute the Document
     except as expressly provided under this License.  Any attempt
     otherwise to copy, modify, sublicense, or distribute it is void,
     and will automatically terminate your rights under this License.

     However, if you cease all violation of this License, then your
     license from a particular copyright holder is reinstated (a)
     provisionally, unless and until the copyright holder explicitly
     and finally terminates your license, and (b) permanently, if the
     copyright holder fails to notify you of the violation by some
     reasonable means prior to 60 days after the cessation.

     Moreover, your license from a particular copyright holder is
     reinstated permanently if the copyright holder notifies you of the
     violation by some reasonable means, this is the first time you have
     received notice of violation of this License (for any work) from
     that copyright holder, and you cure the violation prior to 30 days
     after your receipt of the notice.

     Termination of your rights under this section does not terminate
     the licenses of parties who have received copies or rights from
     you under this License.  If your rights have been terminated and
     not permanently reinstated, receipt of a copy of some or all of
     the same material does not give you any rights to use it.

 10. FUTURE REVISIONS OF THIS LICENSE

     The Free Software Foundation may publish new, revised versions of
     the GNU Free Documentation License from time to time.  Such new
     versions will be similar in spirit to the present version, but may
     differ in detail to address new problems or concerns.  See
     `http://www.gnu.org/copyleft/'.

     Each version of the License is given a distinguishing version
     number.  If the Document specifies that a particular numbered
     version of this License "or any later version" applies to it, you
     have the option of following the terms and conditions either of
     that specified version or of any later version that has been
     published (not as a draft) by the Free Software Foundation.  If
     the Document does not specify a version number of this License,
     you may choose any version ever published (not as a draft) by the
     Free Software Foundation.  If the Document specifies that a proxy
     can decide which future versions of this License can be used, that
     proxy's public statement of acceptance of a version permanently
     authorizes you to choose that version for the Document.

 11. RELICENSING

     "Massive Multiauthor Collaboration Site" (or "MMC Site") means any
     World Wide Web server that publishes copyrightable works and also
     provides prominent facilities for anybody to edit those works.  A
     public wiki that anybody can edit is an example of such a server.
     A "Massive Multiauthor Collaboration" (or "MMC") contained in the
     site means any set of copyrightable works thus published on the MMC
     site.

     "CC-BY-SA" means the Creative Commons Attribution-Share Alike 3.0
     license published by Creative Commons Corporation, a not-for-profit
     corporation with a principal place of business in San Francisco,
     California, as well as future copyleft versions of that license
     published by that same organization.

     "Incorporate" means to publish or republish a Document, in whole or
     in part, as part of another Document.

     An MMC is "eligible for relicensing" if it is licensed under this
     License, and if all works that were first published under this
     License somewhere other than this MMC, and subsequently
     incorporated in whole or in part into the MMC, (1) had no cover
     texts or invariant sections, and (2) were thus incorporated prior
     to November 1, 2008.

     The operator of an MMC Site may republish an MMC contained in the
     site under CC-BY-SA on the same site at any time before August 1,
     2009, provided the MMC is eligible for relicensing.

ADDENDUM: How to use this License for your documents
====================================================

To use this License in a document you have written, include a copy of
the License in the document and put the following copyright and license
notices just after the title page:

       Copyright (C)  YEAR  YOUR NAME.
       Permission is granted to copy, distribute and/or modify this document
       under the terms of the GNU Free Documentation License, Version 1.3
       or any later version published by the Free Software Foundation;
       with no Invariant Sections, no Front-Cover Texts, and no Back-Cover
       Texts.  A copy of the license is included in the section entitled ``GNU
       Free Documentation License''.

   If you have Invariant Sections, Front-Cover Texts and Back-Cover
Texts, replace the "with...Texts." line with this:

         with the Invariant Sections being LIST THEIR TITLES, with
         the Front-Cover Texts being LIST, and with the Back-Cover Texts
         being LIST.

   If you have Invariant Sections without Cover Texts, or some other
combination of the three, merge those two alternatives to suit the
situation.

   If your document contains nontrivial examples of program code, we
recommend releasing these examples in parallel under your choice of
free software license, such as the GNU General Public License, to
permit their use in free software.